#include <bits/stdc++.h>
using namespace std;
#pragma GCC optimize("Ofast")

#ifndef LOCAL
#define cerr if(false) cerr
#endif // LOCAL
#define endl "\n"

#define out(x) "[ " << #x << " : " << x << " ]"

template<class T, class T2> inline bool chkmax(T &x, const T2 &y) { return (x < y) ? x = y, 1: 0; }
template<class T, class T2> inline bool chkmin(T &x, const T2 &y) { return (x > y) ? x = y, 1: 0; }

typedef long long ll;
const ll mod = 1e9 + 7;
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

const int MAX_N = 1e4;
int n;
pair<pair<int, int>, int> p[MAX_N];

struct SegTree {
    short tree[MAX_N];

    SegTree() {
        for(int i = 0; i < MAX_N; i ++) {
            tree[i] = -MAX_N;
        }
    }

    void upd(int ind, int val) {
        ind ++;
        for(; ind < MAX_N; ind += ind & (-ind)) {
            chkmax(tree[ind], val);
        }
    }

    int ans(int ind) {
        ind ++;
        ll ret = -MAX_N;
        for(; ind != 0; ind -= ind & (-ind)) {
            chkmax(ret, tree[ind]);
        }
        return ret;
    }
};

SegTree st[MAX_N];

signed main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
#endif // LOCAL

    cin >> n;
    for(int i = 0; i < n; i ++) {
        cin >> p[i].first.first >> p[i].first.second >> p[i].second;
        p[i].second --;
    }

    sort(p, p + n);

    vector<int> c;
    for(int i = 0; i < n; i ++) {
        c.push_back(p[i].first.second);
    }
    sort(c.begin(), c.end());
    c.resize(unique(c.begin(), c.end()) - c.begin());
    for(int i = 0; i < n; i ++) {
        p[i].first.second = lower_bound(c.begin(), c.end(), p[i].first.second) - c.begin();
    }

    ll ret = 0;

    st[0].upd(0, 0);

    int cnt = 0;
    for(int i = 0; i < n; i ++) {
        if(p[i].second) {
            cnt ++;
        }
    }

    if(cnt > n / 2) {
        cnt = n - cnt;
        for(int i = 0; i < n; i ++) {
            p[i].second ^= 1;
        }
    }

    for(int i = 0; i < n; i ++) {
        for(int red = cnt; red >= 0; red --) {
            int who = st[red].ans(p[i].first.second);
            chkmax(ret, who + 1);
            if(p[i].second) {
                st[red + 1].upd(p[i].first.second, who + 1);
            } else {
                st[red].upd(p[i].first.second, who + 1);
            }
        }
    }


    int small = mod;

    for(int i = 0; i <= n; i ++) {
        for(int j = 0; j <= n; j ++) {
            cerr << st[i].ans(j) << " ";
        }
        cerr << endl;
        if(st[i].ans(MAX_N - 2) == ret) {
            chkmin(small, abs(i - (ret - i)));
        }
    }

    cout << ret << " " << small << endl;

    return 0;
}

