#include <bits/stdc++.h>
using namespace std;

#ifndef LOCAL
#define cerr if(false) cerr
#endif // LOCAL
#define endl "\n"

#define out(x) "[ " << #x << " : " << x << " ]"

template<class T, class T2> inline bool chkmax(T &x, const T2 &y) { return (x < y) ? x = y, 1: 0; }
template<class T, class T2> inline bool chkmin(T &x, const T2 &y) { return (x > y) ? x = y, 1: 0; }

typedef long long ll;
const ll mod = 1e9 + 7;
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

const ll MAX_N = 110, MAX_K = 250;
ll dp[MAX_N][MAX_K][MAX_K];
ll arr[MAX_N];
ll n, k;

void solve() {
    cin >> n >> k;
    for(ll i = 0; i < n; i ++) {
        cin >> arr[i];
    }

    for(ll i = 0; i <= n; i ++) {
        for(ll j = 0; j <= k; j ++) {
            for(ll l = 0; l <= k; l ++) {
                dp[i][j][l] = 1e18;
            }
        }
    }

    for(ll i = 0; i <= k; i ++) {
        dp[0][i][i] = 0;
    }

    for(ll i = 1; i < n; i ++) {
        for(ll j = 0; j <= k; j ++) {
            for(ll l = j; l <= k; l ++) {
                for(ll r = 0; r <= k; r ++) {
                    chkmin(dp[i][j][l], dp[i - 1][r][l - j] + abs(arr[i - 1] + r - j - arr[i]));
                }
            }
        }
    }

    ll ret = 1e18;
    for(ll i = 0; i <= k; i ++) {
        for(ll j = 0; j <= k; j ++) {
            chkmin(ret, dp[n - 1][i][j]);
        }
    }
    cout << ret << endl;
}

signed main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
#endif // LOCAL

    ll t;
    cin >> t;
    while(t --) {
        solve();
    }

    return 0;
}

