#include<bits/stdc++.h>
using namespace std;

const int nmax=1e6+42;

int n;

long long k;

int inp[nmax];

long long pref[nmax];
int pref_MX[nmax],suff_MX[nmax];

struct info
{
    int l,r;
    int parent;
    int h;
};

info state[nmax];
int parent[nmax];

int root(int node)
{
    if(node==state[node].parent)return node;
    state[node].parent=root(state[node].parent);
    return state[node].parent;
}

void my_merge(int u,int v)
{
    u=root(u);
    v=root(v);

    if(state[u].h!=state[v].h)return;

    //cout<<"merge "<<u<<" "<<v<<endl;

    state[u].r=state[v].r;
    state[v].parent=u;
}

priority_queue< pair<int/*SZ*/,int/*root*/> > pq,idle;

vector< pair<long long/*cost*/,long long/*times*/> > seen[4];

void eval()
{
    seen[1]={};
    seen[2]={};

    //cout<<"---"<<endl;

    //cout<<"eval "<<l<<" "<<r<<" "<<k_remain<<" -> ";

    inp[0]=1e9+1;
    inp[n+1]=1e9+1;

    for(int j=0;j<=n+1;j++)
    {
        state[j].l=j;
        state[j].r=j;
        state[j].h=inp[j];
        state[j].parent=j;
    }

    for(int j=1;j<n;j++)
        my_merge(j,j+1);

    pq=idle;

    for(int j=1;j<=n;j++)
        if(root(j)==j)
            pq.push({-(state[root(j)].r-state[root(j)].l+1),root(j)});

    //cout<<"score= "<<score<<endl;

    while(pq.size())
    {
        pair<int/*SZ*/,int/*root*/> tp=pq.top();
        pq.pop();

        //cout<<"tp "<<tp.first<<" "<<tp.second<<" "<<root(tp.second)<<" "<<state[root(tp.second)].r-state[root(tp.second)].l+1<<endl;

        if(root(tp.second)!=tp.second||state[root(tp.second)].r-state[root(tp.second)].l+1!=-tp.first)continue;

        int node=tp.second;

        int h_LHS=state[root(state[node].l-1)].h;
        int h_RHS=state[root(state[node].r+1)].h;

        //cout<<"h_LHS= "<<h_LHS<<" h_RHS= "<<h_RHS<<endl;

        if(h_LHS<state[node].h||h_RHS<state[node].h)continue;

        //cout<<tp.first<<" "<<tp.second<<" "<<state[node].l<<" "<<state[node].r<<" "<<state[node].h;

        long long up=min(h_LHS,h_RHS)-state[node].h;

        state[node].h+=up;

        //cout<<" up= "<<up;

        int coeff=0;

        if(root(state[node].l-1)!=0)
        {
            my_merge(root(state[node].l-1),node);
            coeff++;
        }

        if(root(state[node].r+1)!=n+1)
        {
            my_merge(node,root(state[node].r+1));
            coeff++;
        }

        node=root(node);

        //cout<<" node= "<<node<<" "<<state[node].l<<" "<<state[node].r<<endl;

        if(state[node].l!=0&&state[node].r!=n+1&&up)pq.push({-(state[node].r-state[node].l+1),node});

        //cout<<" with coeff= "<<coeff<<endl;

        if(coeff)
        {
            //cout<<"add "<<coeff<<" "<<-tp.first<<" "<<up<<endl;

            seen[coeff].push_back(make_pair(-tp.first,up));
        }
    }
}

int dp[102][250][250];

int rec(int pos,int prv,int k_remain)
{
    if(pos>n)return 0;

    if(dp[pos][prv][k_remain]!=-1)return dp[pos][prv][k_remain];

    int ret=1e9;

    for(int j=0;j<=k_remain;j++)
        ret=min(ret,rec(pos+1,inp[pos]+j,k_remain-j)+abs(inp[pos]+j-prv));

    dp[pos][prv][k_remain]=ret;
    return ret;
}

int dumb()
{
    for(int i=1;i<=n;i++)
    {
        for(int j=0;j<=k+40;j++)
            for(int p=0;p<=k;p++)
                dp[i][j][p]=-1;
    }

    int outp=1e9;

    for(int i=0;i<=k;i++)
        outp=min(outp,rec(2,inp[1]+i,k-i));

    return outp;
}


long long solve()
{
    /*
    n=7;
    k=rand()%30+1;

    for(int i=1;i<=n;i++)inp[i]=rand()%10+1;

    cout<<n<<" "<<k<<endl;
    for(int i=1;i<=n;i++)cout<<inp[i]<<" ";cout<<endl;
    */

    scanf("%i%lld",&n,&k);

    for(int i=1;i<=n;i++)scanf("%i",&inp[i]);

    seen[1]={};
    seen[2]={};

    eval();

    seen[1].push_back(make_pair(k+1,1));
    seen[2].push_back(make_pair(k+1,1));

    sort(seen[1].begin(),seen[1].end());
    sort(seen[2].begin(),seen[2].end());

    /*
    for(int j=1;j<=2;j++)
    {
        cout<<"seen "<<j<<" -> ";

        for(int p=0;p<seen[j].size();p++)
            cout<<seen[j][p].first<<" "<<seen[j][p].second<<"\t";

        cout<<endl;
    }
    */

    long long sub=0;

    long long cost_now_2=0;
    long long saved_2=0;

    for(int i=0;i<seen[2].size()&&cost_now_2<=k;i++)
    {
        long long saved_1=0,cost_now_1=0;

        for(int j=0;j<seen[1].size()&&cost_now_1+cost_now_2<=k&&seen[1][j].first*2<=seen[2][i].first;j++)
        {
            //cout<<"cost: "<<cost_now_1<<" "<<cost_now_2<<endl;

            //spam cost 1
            sub=max(sub,saved_1+saved_2+min((k-cost_now_1-cost_now_2)/seen[1][j].first,1LL*seen[1][j].second));

            //cout<<i<<" "<<j<<" sub= "<<sub<<endl;

            //spam cost 2
            sub=max(sub,saved_1+saved_2+min((k-cost_now_1-cost_now_2)/seen[2][i].first,1LL*seen[2][i].second)*2LL);

            //cout<<i<<" "<<j<<" sub= "<<sub<<endl;

            //spam cost 2+one of cost 1
            if(cost_now_1+cost_now_2+seen[1][j].first<=k)sub=max(sub,saved_1+saved_2+1+min((k-cost_now_1-cost_now_2-seen[1][j].first)/seen[2][i].first,1LL*seen[2][i].second)*2LL);

            if(j)
            {
                saved_1--;
                cost_now_1-=seen[1][j-1].first;

                //spam cost 1
                sub=max(sub,saved_1+saved_2+min((k-cost_now_1-cost_now_2)/seen[1][j].first,1LL*seen[1][j].second));

                //cout<<i<<" "<<j<<" sub= "<<sub<<endl;

                //spam cost 2
                sub=max(sub,saved_1+saved_2+min((k-cost_now_1-cost_now_2)/seen[2][i].first,1LL*seen[2][i].second)*2LL);

                //cout<<i<<" "<<j<<" sub= "<<sub<<endl;

                //spam cost 2+one of cost 1
                if(cost_now_1+cost_now_2+seen[1][j].first<=k)sub=max(sub,saved_1+saved_2+1+min((k-cost_now_1-cost_now_2-seen[1][j].first)/seen[2][i].first,1LL*seen[2][i].second)*2LL);

                saved_1++;
                cost_now_1+=seen[1][j-1].first;
            }

            //cout<<i<<" "<<j<<" sub= "<<sub<<endl;

            cost_now_1+=1LL*seen[1][j].second*seen[1][j].first;
            saved_1+=1LL*seen[1][j].second;
        }

        cost_now_2+=1LL*seen[2][i].second*seen[2][i].first;
        saved_2+=2*seen[2][i].second;
    }

    long long outp=-sub;
    for(int j=1;j<n;j++)
        outp+=abs(inp[j]-inp[j+1]);

    //cout<<outp<<" "<<dumb()<<endl;

    //assert(outp==dumb());

    return outp;
}

int main()
{
    int t;

    //t=1e5;
    scanf("%i",&t);

    while(t)
    {
        t--;

        //solve();

        printf("%lld\n",solve());
    }

    return 0;
}