#include<bits/stdc++.h>
using namespace std;
const int MAXN=1e6+6;
int n,k;
int a[MAXN];
const int INF=1e9;
struct segment
{
    int l,r;
    int len;
    int ma;
    int val;
    bool operator<(segment const& other)const
    {
        return r-l+1<other.r-other.l+1;
    }
};
vector<segment>seg[3];
struct segment_tree
{
    pair<int,int> t[4*MAXN];
    void build(int l,int r,int idx)
    {
        if(l==r)
        {
            t[idx]={a[l],l};
            return;
        }
        int mid=(l+r)/2;
        build(l,mid,idx*2);
        build(mid+1,r,idx*2+1);
        t[idx]=max(t[idx*2],t[idx*2+1]);
    }
    pair<int,int> query(int l,int r,int idx,int ql,int qr)
    {
        if(l>=ql&&r<=qr)return t[idx];
        int mid=(l+r)/2;
        if(qr<=mid)return query(l,mid,idx*2,ql,qr);
        if(ql>mid)return query(mid+1,r,idx*2+1,ql,qr);
        return max(query(l,mid,idx*2,ql,qr),query(mid+1,r,idx*2+1,ql,qr));
    }
}tr;
void dc(int l,int r,int p)
{
    if(l>r)return;
    int m=tr.query(1,n,1,l,r).second;
    dc(l,m-1,a[m]);
    dc(m+1,r,a[m]);
    int val=2;
    if(l==1||r==n)val=1;
    if(l==1&&r==n)val=0;
    if(p-a[m]!=0)seg[val].push_back({l,r,r-l+1,p-a[m],val});
}
int find_opt(int ma1,int len1,int ma2,int len2,int maxk)
{
    if(maxk<0)return -INF;
    int ret=0;
    for(int i1=0;i1<=ma1;i1++)
    {
        for(int i2=0;i2<=ma2;i2++)
        {
            if(i1*len1+i2*len2>maxk)break;
            ret=max(ret,i1+i2*2);
        }
    }
    return ret;
}
void solve()
{
    cin>>n>>k;
    int v=0;
    for(int i=1;i<=n;i++)cin>>a[i];
    for(int i=2;i<=n;i++)
    {
        v+=abs(a[i]-a[i-1]);
    }
    tr.build(1,n,1);
    seg[0].clear();
    seg[1].clear();
    seg[2].clear();
    dc(1,n,0);
    sort(seg[0].begin(),seg[0].end());
    sort(seg[1].begin(),seg[1].end());
    sort(seg[2].begin(),seg[2].end());
    /*for(int i=0;i<3;i++)
    {
        cout<<"seg "<<i<<endl;
        for(auto xd:seg[i])
        {
            cout<<xd.len<<" "<<xd.ma;
            cout<<endl;
        }
    }*/
    int needed=0,sum1=0,ans=0;
    for(int i=0;i<seg[1].size();i++)
    {
        if(needed<=k&&needed+seg[1][i].ma*seg[1][i].len>k)
        {
            ans=max(ans,sum1+(k-needed)/seg[1][i].len);
        }
        needed+=seg[1][i].ma*seg[1][i].len;
        sum1+=seg[1][i].ma;
        if(needed<=k)ans=max(ans,sum1);
    }
    int bck=seg[1].size()-1;
    for(int i=0;i<seg[2].size();i++)
    {
        if(needed>=k&&bck==-1)break;
        while(needed>=k&&bck>=0)
        {
            needed-=seg[1][bck].ma*seg[1][bck].len;
            sum1-=seg[1][bck].ma;
            bck--;
        }
        //if(needed>=k&&bck==-1)break;
        for(;;)
        {
            if(bck+1<seg[1].size())ans=max(ans,sum1+find_opt(seg[1][bck+1].ma,seg[1][bck+1].len,seg[2][i].ma,seg[2][i].len,k-needed));
            else if(needed<=k)ans=max(ans,sum1+min(seg[2][i].ma,(k-needed)/seg[2][i].len)*2);
            bool flag=0;
            if(needed+seg[2][i].len*seg[2][i].ma>=k&&bck>=0)
            {
                flag=1;
                needed-=seg[1][bck].ma*seg[1][bck].len;
                sum1-=seg[1][bck].ma;
                bck--;
            }
            if(!flag)break;
        }
        sum1+=seg[2][i].ma*2;
        needed+=seg[2][i].len*seg[2][i].ma;
    }
    cout<<v-ans<<endl;
}
signed main()
{
    int t;
    cin>>t;
    while(t--)solve();
return 0;
}
/*
3
6 2
6 3 3 3 4 3
6 3
6 3 3 3 4 3
2 10
1 5
*/
