#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

struct edge
{
    int v, st;
    edge() {}
    edge(int a, int b)
    {
        v=a;
        st=b;
    }
};

int n, m, s, t;

vector<int> gr[100005];

int dist[100005];
bool used[100005];

queue<int> qu;

int st_bfs(int v1)
{
    memset(used, 0, sizeof(used));
    memset(dist, 0, sizeof(dist));
    qu.push(v1);
    used[v1]=1;
    while(!qu.empty())
    {
        int tek=qu.front();
        qu.pop();
        int brs=gr[tek].size();
        for(int i=0; i<brs; i++)
        {
            int nv=gr[tek][i];
            if(used[nv]) continue;
            used[nv]=1;
            dist[nv]=dist[tek]+1;
            qu.push(nv);
        }
    }
    if(used[s]) return dist[s];
    else return -1;
}

int best2[100005];

vector<edge> gr2[100005];

vector<int> res;
int par[100005];
int ndist[100005];

bool pos(int st)
{
    memset(par, 0, sizeof(par));
    memset(used, 0, sizeof(used));
    memset(ndist, 0, sizeof(ndist));
    par[t]=t;
    ndist[t]=0;
    used[t]=1;
    qu.push(t);
    while(!qu.empty())
    {
        int tv=qu.front();
        qu.pop();
        int brs=gr2[tv].size();
        for(int i=0; i<brs; i++)
        {
            int nv=gr2[tv][i].v, vst=gr2[tv][i].st;
            if(used[nv]) continue;
            if(ndist[tv]+vst>st) continue;
            else
            {
                ndist[nv]=ndist[tv]+1;
                used[nv]=1;
                qu.push(nv);
                par[nv]=tv;
            }
        }
    }
    if(!used[s] || ndist[s]>st) return 0;
    res.resize(0);
    int posl=s;
    while(par[posl]!=posl)
    {
        res.push_back(posl);
        posl=par[posl];
    }
    res.push_back(posl);
    return 1;
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>m>>s>>t;
    if(s==t)
    {
        cout<<"0 0\n0\n";
        return 0;
    }
    for(int i=0; i<m; i++)
    {
        int v1, v2;
        cin>>v1>>v2;
        if(v1==v2)
        {
            i--;
            m--;
            continue;
        }
        gr[v1].push_back(v2);
        gr[v2].push_back(v1);
    }
    for(int i=0; i<n; i++)
    {
        for(int j=0; j<gr[i].size(); j++)
        {
            int stv=gr[i][j];
            gr[i][j]=i;
            int res=st_bfs(i);
            if(res==-1) continue;
            gr2[i].push_back(edge(stv, res));
            gr[i][j]=stv;
        }
    }
    /**
    for(int i=0; i<n; i++)
    {
        for(int j=0; j<gr2[i].size(); j++) cout<<"{ "<<gr2[i][j].v<<"; "<<gr2[i][j].st<<"} ";
        cout<<endl;
    }*/

    int le=0, ri=3*m+2;
    while(ri-le>1)
    {
        int mid=(le+ri)/2;
        if(pos(mid)) ri=mid;
        else le=mid;
    }
    if(le>3*m) cout<<-1<<endl;
    else
    {
        cout<<ri<<" "<<res.size()-1<<endl;
        for(int i=0; i<res.size(); i++)
        {
            if(i>0) cout<<" ";
            cout<<res[i];
        }
        cout<<endl;
    }
    return 0;
}
/**


*/

