#include<bits/stdc++.h>
#pragma GCC optimize("Ofast")
#define endl '\n'

using namespace std;

struct point
{
    int x, y, ty;
    point() {}
    point(int a, int b, int c)
    {
        x=a;
        y=b;
        ty=c;
    }
};

bool cmp(point p, point q)
{
    if(p.y==q.y) return p.x<q.x;
    return p.y<q.y;
}

int n;
point t[100000];
int segm[400000];
vector<int> rg[400000];

vector<int> tpr;

void update(int v, int le, int ri, int pos, int st, int ty)
{
    if(le>pos || ri<pos) return;
    if(le==ri)
    {
        segm[v]=st;
        rg[v].resize(0);
        for(int i=0; i<tpr.size(); i++) tpr[i]+=ty;
        for(int i=0; i<tpr.size(); i++)
        {
            if(!rg[v].empty() && rg[v][rg[v].size()-1]==tpr[i]) continue;
            rg[v].push_back(tpr[i]);
        }
        return;
    }
    int mid=(le+ri)/2;
    update(2*v, le, mid, pos, st, ty);
    update(2*v+1, mid+1, ri, pos, st, ty);
    if(segm[2*v]>segm[2*v+1])
    {
        segm[v]=segm[2*v];
        rg[v]=rg[2*v];
    }
    else if(segm[2*v]<segm[2*v+1])
    {
        segm[v]=segm[2*v+1];
        rg[v]=rg[2*v+1];
    }
    else
    {
        segm[v]=segm[2*v];
        int i1=0, i2=0, t=0, s1=rg[2*v].size(), s2=rg[2*v+1].size();
        rg[v].resize(0);
        while(i1<s1 || i2<s2)
        {
            if(i1==s1 || (i2<s2 && rg[2*v][i1]>rg[2*v+1][i2]))
            {
                rg[v].push_back(rg[2*v+1][i2]);
                i2++;
            }
            else
            {
                if(i2<s2 && rg[2*v][i1]==rg[2*v+1][i2]) i2++;
                rg[v].push_back(rg[2*v][i1]);
                i1++;
            }
        }
    }
}

int query(int v, int le, int ri, int be, int en)
{
    if(le>en || ri<be) return 0;
    if(be<=le && ri<=en) return segm[v];
    else
    {
        int mid=(le+ri)/2;
        int st1=query(2*v, le, mid, be, en);
        int st2=query(2*v+1, mid+1, ri, be, en);
        return max(st1, st2);
    }
}


void query2(int v, int le, int ri, int be, int en, int st)
{
    if(le>en || ri<be) return;
    if(be<=le && ri<=en)
    {
        if(segm[v]!=st) return;
        for(int i=0; i<rg[v].size(); i++) tpr.push_back(rg[v][i]);
    }
    else
    {
        int mid=(le+ri)/2;
        query2(2*v, le, mid, be, en, st);
        query2(2*v+1, mid+1, ri, be, en, st);
    }

}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n;
    for(int i=0; i<n; i++)
    {
        cin>>t[i].x>>t[i].y>>t[i].ty;
    }
    for(int i=0; i<4*n; i++) rg[i+1].push_back(0);
    sort(t, t+n, cmp);
    for(int i=0; i<n; i++)
    {
        int tx=t[i].x, tt=t[i].ty;
        if(tt==2) tt=-1;
        int st=query(1, 1, n, 1, tx);
        tpr.resize(0);
        query2(1, 1, n, 1, tx, st);
        sort(tpr.begin(), tpr.end());
        update(1, 1, n, tx, st+1, tt);

    }
    int res=query(1, 1, n, 1, n);
    int bestabs=1e9;
    for(int i=0; i<rg[1].size(); i++)
    {
        if(rg[1][i]<bestabs && -rg[1][i]<bestabs) bestabs=max(rg[1][i], -rg[1][i]);
    }
    cout<<res<<" "<<bestabs<<endl;
    return 0;
}
/**
4
1 2 1
2 1 2
3 1 1
4 3 2
3
1 1 1
2 2 1
3 3 1
*/

