#include <bits/stdc++.h>
using namespace std;

const int maxn = 50004;
int n;
pair <pair <int, int>, int> a [maxn];
bitset<2 * maxn> emptyBS;

pair <int, bitset<2 * maxn> > tree [3 * maxn];
void upd (int l, int r, int pos, int x, pair <int, bitset<2 * maxn> > val){
    if (l == r){
        tree [pos] = val;
        return;
    }
    int mid = l + r >> 1;
    if (x <= mid) upd (l, mid, pos << 1, x, val);
    else upd (mid + 1, r, pos << 1 | 1, x, val);
    if (tree [pos << 1].first > tree [pos << 1 | 1].first) tree [pos] = tree [pos << 1];
    else if (tree [pos << 1].first < tree [pos << 1 | 1].first) tree [pos] = tree [pos << 1 | 1];
    else{
        tree [pos].first = tree [pos << 1].first;
        tree [pos].second = tree [pos << 1].second | tree [pos << 1 | 1].second;
    }
}
pair <int, bitset<2 * maxn> > query (int l, int r, int pos, int ql, int qr){
    if (l > qr || r < ql) return {0, emptyBS};
    if (l >= ql && r <= qr) return tree [pos];
    int mid = l + r >> 1;
    auto q1 = query (l, mid, pos << 1, ql, qr);
    auto q2 = query (mid + 1, r, pos << 1 | 1, ql, qr);
    if (q1.first > q2.first) return q1;
    else if (q1.first < q2.first) return q2;
    else return {q1.first, q1.second | q2.second};
}

int main (){

    ios::sync_with_stdio (false);
    cin.tie (0);

    cin >> n;
    for (int i = 0; i < n; i ++) cin >> a [i].first.first >> a [i].first.second >> a [i].second;
    sort (a, a + n);
    for (int i = 0; i < n; i ++){
        auto p = query (1, n, 1, 1, a [i].first.second);
        p.first ++;
        if (p.first == 1){
            if (a [i].second == 1) p.second [maxn - 1] = 1;
            else p.second [maxn + 1] = 1;
        }
        else{
            if (a [i].second == 1) p.second >>= 1;
            else p.second <<= 1;
        }
        upd (1, n, 1, a [i].first.second, p);
    }
    auto p = query (1, n, 1, 1, n);
    cout << p.first << ' ';
    for (int i = 0; i <= p.first; i ++){
        if (p.second [maxn - i] || p.second [maxn + i]){
            cout << i << '\n';
            break;
        }
    }

}
