#include <bits/stdc++.h>
using namespace std;

const int maxn = 50004;
int n;
pair <pair <int, int>, int> a [maxn];
bitset<2 * maxn> emptyBS;

pair <int, bitset<2 * maxn> > fenwick [maxn];
void upd(int x, pair<int, bitset<2 * maxn> > val){
    while (x <= n){
        if (fenwick [x].first < val.first) fenwick [x] = val;
        else if (fenwick [x].first == val.first) fenwick [x].second |= val.second;
        x += x ^ -x;
    }
}
pair <int, bitset<2 * maxn> > query(int x){
    pair <int, bitset<2 * maxn> > ans = {0, emptyBS};
    while (x > 0){
        if (ans.first < fenwick [x].first) ans = fenwick [x];
        else if (ans.first == fenwick [x].first) ans.second |= fenwick [x].second;
        x -= x ^ -x;
    }
    return ans;
}

int main (){

    ios::sync_with_stdio (false);
    cin.tie (0);

    cin >> n;
    for (int i = 0; i < n; i ++) cin >> a [i].first.first >> a [i].first.second >> a [i].second;
    sort (a, a + n);
    for (int i = 0; i < n; i ++){
        auto p = query (a [i].first.second);
        p.first ++;
        if (p.first == 1){
            if (a [i].second == 1) p.second [maxn - 1] = 1;
            else p.second [maxn + 1] = 1;
        }
        else{
            if (a [i].second == 1) p.second >>= 1;
            else p.second <<= 1;
        }
        upd (a [i].first.second, p);
    }
    auto p = query (n);
    cout << p.first << ' ';
    for (int i = 0; i <= p.first; i ++){
        if (p.second [maxn - i] || p.second [maxn + i]){
            cout << i << '\n';
            break;
        }
    }

}
