#include <bits/stdc++.h>
using namespace std;

const int maxn = 50004;
int n;
pair <pair <int, int>, int> a [maxn];
int zero = 1;

pair <int, bitset<maxn> > fenwick [maxn];
void upd(int x, pair<int, bitset<maxn> > &val){
    while (x <= n){
        if (fenwick [x].first < val.first) fenwick [x] = val;
        else if (fenwick [x].first == val.first) fenwick [x].second |= val.second;
        x += x & -x;
    }
}
pair <int, bitset<maxn> > ans;
pair <int, bitset<maxn> > query(int x){
    ans = {0, 0};
    while (x > 0){
        if (ans.first < fenwick [x].first) ans = fenwick [x];
        else if (ans.first == fenwick [x].first) ans.second |= fenwick [x].second;
        x -= x & -x;
    }
    return ans;
}

int main (){

    ios::sync_with_stdio (false);
    cin.tie (0);

    cin >> n;
    for (int i = 0; i < n; i ++){
        cin >> a [i].first.first >> a [i].first.second >> a [i].second;
        if (a [i].second == 1) zero ++;
    }
    sort (a, a + n);
    pair <int, bitset<maxn> > p;
    for (int i = 0; i < n; i ++){
        p = query (a [i].first.second);
        p.first ++;
        if (p.first == 1){
            if (a [i].second == 1) p.second [zero - 1] = 1;
            else p.second [zero + 1] = 1;
        }
        else{
            if (a [i].second == 1) p.second >>= 1;
            else p.second <<= 1;
        }
        upd (a [i].first.second, p);
    }
    p = query (n);
    cout << p.first << ' ';
    for (int i = 0; i <= p.first; i ++){
        if (p.second [zero - i] || p.second [zero + i]){
            cout << i << '\n';
            break;
        }
    }

}
