#include <bits/stdc++.h>
using namespace std;

const int maxn = 1000006;
long long t, n, k;
int a [maxn];
long long ans;

struct node{
    long long val, sz;
    node *l, *r;
    node(long long val){
        this->val = val;
        sz = 1;
        l = r = nullptr;
    }
};
using pnode = node*;
pnode first, last;
vector<pnode> nodes;
priority_queue <pair <int, int> > pq;

void mergeFirst(){
    long long x = (first->r->val - first->val) * first->sz;
    if (x > k){
        ans -= k / first->sz;
        k -= k / first->sz * first->sz;
    }
    else{
        k -= x;
        ans -= first->r->val - first->val;
        pnode pp = new node(first->r->val);
        pp->sz = first->sz + first->r->sz;
        if (!first->r->r) last = pp;
        else{
            pp->r = first->r->r;
            first->r->r->l = pp;
        }
        first = pp;
    }
}
void mergeLast(){
    long long x = (last->l->val - last->val) * last->sz;
    if (x > k){
        ans -= k / last->sz;
        k -= k / last->sz * last->sz;
    }
    else{
        k -= x;
        ans -= last->l->val - last->val;
        pnode pp = new node(last->l->val);
        pp->sz = last->sz + last->l->sz;
        if (!last->l->l) first = pp;
        else{
            pp->l = last->l->l;
            last->l->l->r = pp;
        }
        last = pp;
    }
}
void mergeL(pnode p){
    long long x = (p->l->val - p->val) * p->sz;
    if (x > k){
        ans -= k / p->sz * 2;
        k -= k / p->sz * p->sz;
    }
    else{
        k -= x;
        ans -= (p->l->val - p->val) * 2;
        pnode pp = new node(p->l->val);
        pp->sz = p->sz + p->l->sz;
        pp->r = p->r;
        p->r->l = pp;
        if (!p->l->l) first = pp;
        else{
            p->l->l->r = pp;
            pp->l = p->l->l;
            if (pp->l->val > pp->val){
                pq.push({-pp->sz, nodes.size ()});
                nodes.push_back(pp);
            }
        }
    }
}
void mergeR(pnode p){
    long long x = (p->r->val - p->val) * p->sz;
    if (x > k){
        ans -= k / p->sz * 2;
        k -= k / p->sz * p->sz;
    }
    else{
        k -= x;
        ans -= (p->r->val - p->val) * 2;
        pnode pp = new node(p->r->val);
        pp->sz = p->sz + p->r->sz;
        pp->l = p->l;
        p->l->r = pp;
        if (!p->r->r) last = pp;
        else{
            p->r->r->l = pp;
            pp->r = p->r->r;
            if (pp->r->val > pp->val){
                pq.push({-pp->sz, nodes.size ()});
                nodes.push_back(pp);
            }
        }
    }
}
void mergeBoth(pnode p){
    long long x = (p->l->val - p->val) * p->sz;
    if (x > k){
        ans -= k / p->sz * 2;
        k -= k / p->sz * p->sz;
    }
    else{
        k -= x;
        ans -= (p->l->val - p->val) * 2;
        pnode pp = new node(p->l->val);
        pp->sz = p->l->sz + p->sz + p->r->sz;
        if (!p->l->l) first = pp;
        else{
            p->l->l->r = pp;
            pp->l = p->l->l;
        }
        if (!p->r->r) last = pp;
        else{
            p->r->r->l = pp;
            pp->r = p->r->r;
        }
        if (pp->l && pp->l->val > pp->val && pp->r && pp->r->val > pp->val){
                pq.push({-pp->sz, nodes.size ()});
                nodes.push_back(pp);
            }
    }
}
void mergeFirst2(){
    if (first->r->val >= first->val + 2){
        long long x = (first->r->val - first->val) / 2 * 2 * first->sz;
        if (k < x){
            ans -= k / (2 * first->sz) * 2;
            k -= k / (2 * first->sz) * 2 * first->sz;
        }
        else{
            k -= x;
            ans -= (first->r->val - first->val) / 2 * 2;
            if ((first->r->val - first->val) % 2 == 1) first->val = first->r->val - 1;
            else{
                pnode pp = new node (first->r->val);
                pp->sz = first->sz + first->r->sz;
                if (!first->r->r) last = pp;
                else{
                    pp->r = first->r->r;
                    first->r->r->l = pp;
                }
                first = pp;
            }
        }
    }
    else{
        long long x = 2 * first->sz + first->r->sz;
        k -= x;
        ans -= 2;
        pnode pp = new node (first->r->val + 1);
        if (first->r->r->val >= first->r->val + 2){
            pp->sz = first->sz + first->r->sz;
            pp->r = first->r->r;
            first->r->r->l = pp;
        }
        else{
            pp->sz = first->sz + first->r->sz + first->r->r->sz;
            if (!first->r->r->r) last = pp;
            else{
                pp->r = first->r->r->r;
                first->r->r->r->l = pp;
            }
        }
        first = pp;
    }
}
void mergeLast2(){
    if (last->l->val >= last->val + 2){
        long long x = (last->l->val - last->val) / 2 * 2 * last->sz;
        if (k < x){
            ans -= k / (2 * last->sz) * 2;
            k -= k / (2 * last->sz) * 2 * last->sz;
        }
        else{
            k -= x;
            ans -= (last->l->val - last->val) / 2 * 2;
            if ((last->l->val - last->val) % 2 == 1) last->val = last->l->val - 1;
            else{
                pnode pp = new node (last->l->val);
                pp->sz = last->sz + last->l->sz;
                if (!last->l->l) first = pp;
                else{
                    pp->l = last->l->l;
                    last->l->l->r = pp;
                }
                last = pp;
            }
        }
    }
    else{
        long long x = 2 * last->sz + last->l->sz;
        k -= x;
        ans -= 2;
        pnode pp = new node (last->l->val + 1);
        if (last->l->l->val >= last->l->val + 2){
            pp->sz = last->sz + last->l->sz;
            pp->l = last->l->l;
            last->l->l->r = pp;
        }
        else{
            pp->sz = last->sz + last->l->sz + last->l->l->sz;
            if (!last->l->l->l) first = pp;
            else{
                pp->l = last->l->l->l;
                last->l->l->l->r = pp;
            }
        }
        last = pp;
    }
}

int main (){

    ios::sync_with_stdio (false);
    cin.tie (0);

    cin >> t;
    while (t --){
        cin >> n >> k;
        while (!pq.empty()) pq.pop();
        nodes.clear ();
        ans = 0;
        cin >> a [0];
        first = new node(a [0]);
        pnode p = first;
        for (int i = 1; i < n; i ++){
            cin >> a [i];
            ans += abs (a [i] - a [i - 1]);
            if (a [i] == a [i - 1]) p->sz ++;
            else{
                pnode pp = new node(a [i]);
                p->r = pp;
                pp->l = p;
                if (a [i] > a [i - 1] && p->l && p->l->val > p->val){
                    pq.push({-p->sz, nodes.size ()});
                    nodes.push_back(p);
                }
                p = pp;
            }
        }
        last = p;
        while (first != last && k > 0){
            if (pq.empty()){
                if (first->r->val > first->val && (last->l->val < last->val || first->sz <= last->sz)){
                    if (k < first->sz) break;
                    mergeFirst();
                    continue;
                }
                else if (last->l->val > last->val){
                    if (k < last->sz) break;
                    mergeLast();
                    continue;
                }
                else break;
            }
            auto idx = pq.top();
            pq.pop();
            p = nodes [idx.second];
            int priceP = p->sz;
            if (k < priceP) continue;
            int priceFirst = 1000000000, priceLast = 1000000000;
            if (first->r->val >= first->val + 2) priceFirst = 2 * first->sz;
            else if (first->r->val > first->val && first->r->r && first->r->r->val > first->r->val) priceFirst = 2 * first->sz + first->r->sz;
            if (last->l->val >= last->val + 2) priceLast = 2 * last->sz;
            else if (last->l->val > last->val && last->l->l && last->l->l->val > last->l->val) priceLast = 2 * last->sz + last->l->sz;
            if (priceP <= priceFirst && priceP <= priceLast){
                if (p->l->val < p->r->val) mergeL(p);
                else if (p->l->val > p->r->val) mergeR(p);
                else mergeBoth(p);
            }
            else if (priceFirst <= priceLast) mergeFirst2();
            else mergeLast2();
        }
        cout << ans << '\n';
    }

}
