# include <bits/stdc++.h>
using namespace std;
const int maxn = 5005;
int dp[maxn][maxn];
struct segment_tree
{
    int segm[1005];
    void update(int v, int from, int to, int x, int d)
    {
        if(from==to)
        {
            segm[v] = d;
            return ;
        }
        int mid = (from+to)/2;
        if(x<=mid)update(2*v,from,mid,x,d);
        else
            update(2*v+1,mid+1,to,x,d);
        segm[v] = max(segm[2*v],segm[2*v+1]);
        return ;
    }
    int query(int v, int from, int to, int l, int r)
    {
        if(l<=from&&to<=r)return segm[v];
        int mid = (from+to)/2;
        int ans = 0;
        if(l<=mid)ans = query(2*v,from,mid,l,r);
        if(r>mid)ans = max(ans,query(2*v+1,mid+1,to,l,r));
        return ans;
    }
} ;
segment_tree ap[1005];
struct ty
{
    int x, y;
    int type;
};
vector <ty> g;
bool cmp(ty i, ty j)
{
    if(i.y==j.y)return i.x<j.x;
    return i.y < j.y;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin>>n;
    g.resize(n);
    int i,j;
    for(i = 0;i<n;i++)
        cin>>g[i].x>>g[i].y>>g[i].type;
    sort(g.begin(),g.end(),cmp);
    int t;
    int pluss = 400;
    int maxans = 0;
    int mindiff = 1e9;

    for(i = 0;i < n; i++)
    {
        for(t = -n; t <= n; t++)
        {
            if(g[i].type==1 && t+pluss-1 >= 0)
            {
                 dp[i][t+pluss] = ap[t+pluss-1].query(1,1,n,1,g[i].x)+1;
                if(dp[i][t+pluss]==1 && abs(t)!=1)dp[i][t+pluss] = 0;
            }
            if(g[i].type==2 && t+pluss+1 <= 1000)
            {
                 dp[i][t+pluss] = ap[t+pluss+1].query(1,1,n,1,g[i].x)+1;
                     if(dp[i][t+pluss]==1 && abs(t)!=1)dp[i][t+pluss] = 0;
            }
            if(maxans < dp[i][t+pluss])
            {
                maxans = dp[i][t+pluss];
                mindiff = abs(t);
            }
            else
                if(maxans==dp[i][t+pluss] && abs(t) < mindiff)mindiff = abs(t);

        }
         for(t = -n; t <= n; t++)
         {
              if(dp[i][t+pluss]!=1 || abs(t)== 1)
                 {
                     ap[t+pluss].update(1,1,n,g[i].x,dp[i][t+pluss]);
                 }
         }
    }
    cout<<maxans<<" "<<mindiff<<endl;
}
