#include<bits/stdc++.h>
#define MAXN 100000
using namespace std;

struct cell{
    int x,y,t;
};

struct statedp{
    int ans;
    int up,down;
};

int n,ans,raz;
cell c[MAXN];

bool cmp(cell fr,cell sc){
    if(fr.x!=sc.x)return fr.x<sc.x;
    else return fr.y<sc.y;
}

statedp dp[MAXN];

int fenwick[20007][40007];

void update(int pos,int pos2,int val){
    while(pos<=n){
        fenwick[pos][pos2]=max(fenwick[pos][pos2],val);
        pos+=(pos & (-pos));
    }
}

int getmax(int pos,int pos2){
    int res=-1000000;
    while(pos>=1){
        res=max(fenwick[pos][pos2],res);
        pos-=(pos & (-pos));
    }
    return res;
}

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n;
    for(int i=1;i<=n;i++){
        cin>>c[i].x>>c[i].y>>c[i].t;
    }

    for(int i=0;i<=5000;i++){
        for(int f=0;f<=10000;f++){
            fenwick[i][f]=-1000000;
        }
    }

    sort(c+1,c+n+1,cmp);

    for(int i=1;i<=n;i++){
        for(int r=0;r<=10000;r++)dp[i][r]=-10000000;
        for(int r=5000-i-1;r<=5000+i+1;r++){

            if(c[i].t==1 and r==5001)dp[i][r]=1;
            else if(c[i].t==2 and r==4999)dp[i][r]=1;

            if(c[i].t==1){
                dp[i][r]=max(dp[i][r],getmax(c[i].y,r-1)+1);
            }else{
                dp[i][r]=max(dp[i][r],getmax(c[i].y,r+1)+1);
            }

            if(dp[i][r]>ans){
                ans=dp[i][r]; raz=abs(5000-r);
            }else if(dp[i][r]==ans){
                raz=min(raz,abs(5000-r));
            }
        }
        for(int r=5000-i-1;r<=5000+i+1;r++){
            update(c[i].y,r,dp[i][r]);
        }
    }

    cout<<ans<<" "<<raz<<"\n";

    return 0;
}

