#include <algorithm>
#include <iostream>
#include <utility>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 90000;

struct fruit
{
    int x, y, t;
    fruit(int x, int y, int t)
    {
        this -> x = x;
        this -> y = y;
        this -> t = t;
    }
};

int mx, Abs;
vector<fruit> p;
vector<int> G[MAXN + 5];
vector< pair<int, int> > v[MAXN + 5];

void go(int u, int cnt, int diff)
{
    if (p[u].t == 1)
    {
        cnt++;
        diff++;
    }
    if (p[u].t == 2)
    {
        cnt++;
        diff--;
    }

    if (mx < cnt)
    {
        mx = cnt;
        Abs = (diff > 0 ? diff : -diff);
    }
    else if (mx == cnt)
    {
        Abs = max(Abs, (diff > 0 ? diff : -diff));
    }

    for (auto v : G[u])
    {
        go(v, cnt, diff);
    }
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n;
    cin >> n;

    p.emplace_back(0, 0, 0);
    for (int i = 1; i <= n; ++ i)
    {
        int x, y, t;
        cin >> x >> y >> t;
        p.emplace_back(x, y, t);
    }
    p.emplace_back(n + 1, n + 1, 0);

    sort(p.begin(), p.end(), [](auto fi, auto se)
         {
            if (fi.x != se.x) return fi.x < se.x;
            return fi.y < se.y;
         });

    for (int i = 0; i < p.size(); ++ i)
    {
        v[p[i].x].push_back({p[i].y, i});
    }

    for (int x = 0; x <= n + 1; ++ x)
    {
        sort(v[x].begin(), v[x].end());
    }

    for (int i = 0; i < p.size(); ++ i)
    {
        int mxy = +2 * n;
        int x = p[i].x, y = p[i].y;
        int pos = lower_bound(v[x].begin(), v[x].end(), make_pair(y, 0)) - v[x].begin();
        if (pos + 1 < v[x].size())
        {
            if (mxy > v[x][pos + 1].first - y)
            {
                G[i].push_back(v[x][pos + 1].second);
                mxy = v[x][pos + 1].first - y;
            }
        }
        x++;
        for (; x <= n + 1; ++ x)
        {
            int pos = lower_bound(v[x].begin(), v[x].end(), make_pair(y, 0)) - v[x].begin();
            if (pos < v[x].size())
            {
                if (mxy > v[x][pos].first - y)
                {
                    G[i].push_back(v[x][pos].second);
                    mxy = v[x][pos].first - y;
                }
            }
        }
    }

    go(0, 0, 0);

    cout << mx << " " << Abs << endl;

    return 0;
}
