#include <iostream>
#include <ctime>
#define endl '\n'
using namespace std;

const int MAXN = 100;

int n, k;
time_t start;
int v[MAXN + 5];
int dp[MAXN + 5][2 * MAXN + 5][2 * MAXN + 5];

const int BUFFER_LENGTH = 1000000;

char buffer[BUFFER_LENGTH];
int buffer_pos = 0;

void read_char()
{
    if (++buffer_pos == BUFFER_LENGTH) fread(buffer, 1, BUFFER_LENGTH, stdin), buffer_pos = 0;
}

int int_value;

int read_int()
{
    int_value = 0;
    for (; buffer[buffer_pos] < '0' or buffer[buffer_pos] > '9'; read_char());
    for (; buffer[buffer_pos] >= '0' and buffer[buffer_pos] <= '9'; read_char())
    {
        int_value = int_value * 10 + (buffer[buffer_pos] - '0');
    }
    return int_value;
}

void solve()
{

    n = read_int();
    k = read_int();

    for (int i = 1; i <= n; ++ i)
    {
        v[i] = read_int();
    }

    for (int i = 1; i <= k; ++ i)
    {
        dp[1][i][i] = 0;
    }

    int ans = 60000;
    for (int i = 2; i <= n; ++ i)
    {
        for (int j = k; j >= 0; -- j)
        {
            for (int s = 0; s <= j; ++ s)
            {
                dp[i][j][s] = -1;
                for (int t = 0; t <= j - s; ++ t)
                {
                    if (dp[i][j][s] == -1) dp[i][j][s] = dp[i - 1][j - s][t] + (v[i - 1] + t - v[i] - s > 0 ? v[i - 1] + t - v[i] - s : v[i] + s - v[i - 1] - t);
                    dp[i][j][s] = min(dp[i][j][s], dp[i - 1][j - s][t] + (v[i - 1] + t - v[i] - s > 0 ? v[i - 1] + t - v[i] - s : v[i] + s - v[i - 1] - t));
                }
                if (i == n) ans = min(ans, dp[i][j][s]);

            }
        }
        if (clock() - start > 0.645 * CLOCKS_PER_SEC)
        {
            cout << ans << endl;
            return;
        }
    }

    cout << ans << endl;
}

int main()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    start = clock();

    int t;
    t = read_int();

    while (t--)
    {
        solve();
    }

    return 0;
}
