#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

const int maxn = 1e5, inf = 1e7;
int n, m, s, t, dp[maxn], used[maxn], st[maxn], vis[maxn];

vector < pair < int, int >  > g[maxn], ng[maxn];

struct edge
{
    int v, u;
} e[maxn * 10];

void add_edge(int v, int u, int idx)
{
    g[v].push_back({u, idx});
    g[u].push_back({v, idx});
    ng[v].push_back({u, idx});
    ng[u].push_back({v, idx});
}

void bfs(int idx)
{
    for (int i = 0; i < n; i ++)
        vis[i] = inf;

    queue < int > q;
    q.push(t);
    vis[t] = 0;
    while(!q.empty())
    {
        int v = q.front();
        q.pop();
        for (int i = 0; i < g[v].size(); i ++)
        {
            if (g[v][i].second == idx)
                continue;
            if (vis[g[v][i].first] == inf)
            {
                vis[g[v][i].first] = vis[v] + 1;
                q.push(g[v][i].first);
            }
        }
    }
}
void calc_st()
{
    for (int i = 0; i < n; i ++)
        st[i] = 0;
    for (int i = 1; i <= m; i ++)
    {
        bfs(i);
        for (int j = 0; j < n; j ++)
        {
            st[j] = max(st[j], vis[j]);
        }
    }
}

int fr[maxn];
void solve()
{
    cin >> n >> m >> s >> t;

    for (int i = 1; i <= m; i ++)
    {
        cin >> e[i].v >> e[i].u;
        add_edge(e[i].v, e[i].u, i);
    }

    for (int i = 0; i < n; i ++)
        used[i] = -1, dp[i] = inf;


    calc_st();

    queue < int > q;
    dp[s] = st[s];
    q.push(s);
    for (int i = 0; i < n; i ++)
        fr[i] = -1;

    used[s] = 0;
    while(!q.empty())
    {
        int v = q.front();
        q.pop();
        for (pair < int, int > pp : g[v])
        {
            if (used[pp.first] == -1)
            {
                used[pp.first] = used[v] + 1;
                q.push(pp.first);
            }

            if (used[pp.first] == used[v] + 1)
            {
                int tp = max(dp[v], used[pp.first] + st[pp.first]);
                if (tp < dp[pp.first])
                {
                    dp[pp.first] = tp;
                    fr[pp.first] = v;
                }

            }
        }
    }


    int ans = dp[t];
    if (fr[t] == -1)
    {
        cout << -1 << endl;
        return;
    }

    vector < int > path;
    int v = t;
    path.push_back(v);
    while(fr[v] != -1)
    {
        v = fr[v];
        path.push_back(v);
    }

    cout << ans << " " << path.size() - 1 << endl;
    for (int i = (int)(path.size()) - 1; i >= 0; i --)
        cout << path[i] << " ";
    cout << endl;
}
int main ()
{
    solve();
    return 0;
}
/**
7 10 0 6
4 5
2 5
0 1
0 2
2 3
1 3
3 4
3 5
4 6
5 6
*/
