#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

const int maxn = 1e5 + 10, inf = 1e9;

int n, m, s, t, st[maxn], vis[maxn], dis[maxn], dp[maxn];
vector < pair < int, int > > g[maxn];

void bfs(int idx)
{
    for (int i = 0; i < n; i ++)
        vis[i] = inf;

    vis[t] = 0;
    queue < int > q;
    q.push(t);
    while(!q.empty())
    {
        int v = q.front();
        q.pop();
        for (pair < int, int > nb : g[v])
        {
            if (nb.second == idx)
                continue;

            if (vis[nb.first] == inf)
            {
                vis[nb.first] = vis[v] + 1;
                q.push(nb.first);
            }
        }
    }
}

int fr[maxn];
void solve()
{
    cin >> n >> m >> s >> t;
    for (int i = 1; i <= m; i ++)
    {
        int v, u;
        cin >> v >> u;
        g[v].push_back({u, i});
        g[u].push_back({v, i});
    }

    bfs(0);
    for (int i = 0; i < n; i ++)
        st[i] = vis[i];

    for (int i = 1; i <= m; i ++)
    {
        bfs(i);
        for (int j = 0; j < n; j ++)
            st[j] = max(st[j], vis[j]);
    }

    queue < int > q;
    for (int i = 0; i < n; i ++)
        dis[i] = inf, fr[i] = -1, dp[i] = inf;
    dis[s] = 0;
    q.push(s);
    dp[s] = st[s];
    while(!q.empty())
    {
        int v = q.front();
        q.pop();
        for (pair < int, int > nb : g[v])
        {
            int wd = dis[v] + 1;
            if (dis[nb.first] == inf)
            {
                dis[nb.first] = wd;
                q.push(nb.first);
            }

            if (dis[nb.first] > dis[v])
            {
                ll val = max(dp[v], dis[nb.first] + st[nb.first]);
                if (val < dp[nb.first])
                {
                    dp[nb.first] = val;
                    fr[nb.first] = v;
                }
            }
        }
    }

    if (dp[t] == inf)
        cout << -1 << endl;
    else
    {
        vector < int > path;
        int v = t;
        while(fr[v] != -1)
        {
            path.push_back(v);
            v = fr[v];
        }
        path.push_back(v);
        reverse(path.begin(), path.end());
        cout << dp[t] << " " << (int)(path.size()) - 1 << endl;
        for (int i = 0; i < path.size(); i ++)
            cout << path[i] << " ";
        cout << endl;
    }

}

int main ()
{
    solve();
    return 0;
}
