#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

const int maxn = 1e6 + 10, inf = 1e8;
int n, m, s, t, imp[maxn], used[maxn], st[maxn];
vector < pair < int, int > > g[maxn];

void bfs(int idx)
{
    for (int i = 0; i < n; i ++)
    {
        used[i] = -1;
    }

    queue < int > q;
    q.push(t);
    used[t] = 0;
    while(!q.empty())
    {
        int v = q.front();
        q.pop();
        for (int j = 0; j < g[v].size(); j ++)
        {
            if (g[v][j].second == idx)
                continue;
            if (used[g[v][j].first] != -1)
                continue;
            used[g[v][j].first] = used[v] + 1;
            if (idx == 0)
            imp[g[v][j].second] = 1;
            q.push(g[v][j].first);
        }
    }
}


void calc_st()
{
    for (int i = 0; i < n; i ++)
        st[i] = 0;

        bfs(0);

    for (int i = 1; i <= m; i ++)
    {
     //   if (!imp[i])
       //     continue;
        bfs(i);
        for (int j = 0; j < n; j ++)
        {
            if (used[j] == -1)
                st[j] = inf;
            else
                st[j] = max(st[j], used[j]);
        }
    }

    for (int i = 0; i < n; i ++)
    {
        if (st[i] == 0 && i != t)
            st[i] = inf;
    }
}

int fr[maxn];
bool check(int x)
{
    for (int i = 0; i < n; i ++)
    {
        used[i] = -1;
    }

    if (st[s] > x)
        return false;
    queue < int > q;
    q.push(s);
    fr[s] = -1;
    used[s] = 0;
    while(!q.empty())
    {
        int v = q.front();
        q.pop();
        for (pair < int, int > nb : g[v])
        {
            if (used[nb.first] != -1)
                continue;
            int wd = used[v] + 1;
            if (wd + st[nb.first] <= x)
            {
                used[nb.first] = wd;
                fr[nb.first] = v;
                q.push(nb.first);
            }
        }
    }

    if (used[t] == -1)
        return false;
    return true;

}
void solve()
{
    cin >> n >> m >> s >> t;
    for (int i = 1; i <= m; i ++)
    {
        int v, u;
        cin >> v >> u;
        g[v].push_back({u, i});
        g[u].push_back({v, i});
    }

    bfs(0);
    calc_st();

    int lf = 0, rf = inf;
    while(lf <= rf)
    {
        int mf = (lf + rf) / 2;
        if (check(mf))
            rf = mf - 1;
        else
            lf = mf + 1;
    }

    if (lf == inf + 1)
    {
        cout << -1 << endl;
        return;
    }

    int v = t;
    vector < int > path;
    path.push_back(v);
    while(fr[v] != -1)
    {
        v = fr[v];
        path.push_back(v);
    }

    cout << lf << " " << path.size() - 1 << endl;
    for (int j = (int)(path.size()) - 1; j >= 0; j --)
        cout << path[j] << " ";
    cout << endl;

}

int main ()
{
    solve();
    return 0;
}
