#include<bits/stdc++.h>
using namespace std;

const int nmax=1e5+42,mmax=1e6+42;

int n,m,s,t;

vector< pair<int/*node*/,int/*id*/> > adj[nmax];

pair<int,int> edges[mmax];

vector< pair<int, pair<int,int> > > edges_final;

int dist[nmax];

int mem_dist_from_s[nmax];

queue< pair<int/*node*/,int/*dist*/> > q;

void bfs(int node,int blocked)
{
    for(int i=0;i<n;i++)dist[i]=-1;

    q.push({node,0});

    while(q.size())
    {
        pair<int/*node*/,int/*dist*/> tp=q.front();
        q.pop();

        if(dist[tp.first]!=-1)continue;

        dist[tp.first]=tp.second;

        for(int i=0;i<adj[tp.first].size();i++)
            if(adj[tp.first][i].second!=blocked&&dist[adj[tp.first][i].first]==-1)q.push({adj[tp.first][i].first,tp.second+1});
    }
}

bool been[nmax];

vector<int> path;

vector<int> adj_final[nmax];

int parent[nmax];
int root(int node)
{
    if(node==parent[node])return node;
    parent[node]=root(parent[node]);
    return parent[node];
}

vector<int> to_ret;

void dfs(int node)
{
    if(to_ret.size())return;

    if(been[node])return;

    been[node]=1;

    path.push_back(node);

    if(node==t)to_ret=path;

    for(int i=0;i<adj_final[node].size();i++)
        dfs(adj_final[node][i]);

    path.pop_back();
}

vector<int> test(int SZ)
{
    to_ret={};
    path={};

    for(int i=0;i<n;i++)adj_final[i]={};

    for(int j=0;j<edges_final.size();j++)
        if(edges_final[j].first<=SZ)adj_final[edges_final[j].second.first].push_back(edges_final[j].second.second);

    for(int i=0;i<n;i++)been[i]=0;

    dfs(s);

    return to_ret;
}

int main()
{
    scanf("%i%i%i%i",&n,&m,&s,&t);

    for(int i=1;i<=m;i++)
    {
        int u,v;

        scanf("%i%i",&u,&v);

        edges[i]={u,v};

        adj[u].push_back({v,i});
        adj[v].push_back({u,i});
    }

    bfs(s,0);

    for(int i=0;i<n;i++)mem_dist_from_s[i]=dist[i];

    for(int i=1;i<=m;i++)
    {
        int u=edges[i].first;
        int v=edges[i].second;

        bfs(t,i);

        if(dist[u]!=-1)edges_final.push_back({mem_dist_from_s[u]+dist[u],{u,v}});

        if(dist[v]!=-1)edges_final.push_back({mem_dist_from_s[v]+dist[v],{v,u}});
    }

    sort(edges_final.begin(),edges_final.end());

    int ok=edges_final.size(),not_ok=-1;

    while(ok-not_ok>1)
    {
        int av=(ok+not_ok)/2;

        if(test(edges_final[av].first).size())ok=av;
        else not_ok=av;
    }

    if(ok==edges_final.size())printf("-1\n");
    else
    {
        vector<int> path=test(edges_final[ok].first);

        printf("%i %i\n",edges_final[ok].first,path.size()-1);

        for(int j=0;j<path.size();j++)
            printf("%i ",path[j]);
        printf("\n");
    }

    return 0;
}