#include<bits/stdc++.h>
using namespace std;

const int nmax=1e6+42;

int n;

long long k;

int inp[nmax];

long long pref[nmax];
int pref_MX[nmax],suff_MX[nmax];

struct info
{
    int l,r;
    int parent;
    int h;
};

info state[nmax];
int parent[nmax];

int root(int node)
{
    if(node==state[node].parent)return node;
    state[node].parent=root(state[node].parent);
    return state[node].parent;
}

void my_merge(int u,int v)
{
    u=root(u);
    v=root(v);

    if(state[u].h!=state[v].h)return;

    //cout<<"merge "<<u<<" "<<v<<endl;

    state[u].r=state[v].r;
    state[v].parent=u;
}

priority_queue< pair<int/*SZ*/,int/*root*/> > pq,idle;

long long eval(int l,int r,long long k_remain)
{
    //cout<<"---"<<endl;

    //cout<<"eval "<<l<<" "<<r<<" "<<k_remain<<" -> ";

    for(int j=l;j<=r;j++)
    {
        state[j].l=j;
        state[j].r=j;
        state[j].h=inp[j];
        state[j].parent=j;
    }

    for(int j=l;j<r;j++)
        my_merge(j,j+1);

    long long score=0;
    for(int j=l;j<r;j++)
        if(1<=j&&j+1<=n)score+=abs(inp[j]-inp[j+1]);

    pq=idle;

    for(int j=l+1;j<r;j++)
        if(state[root(j)].l!=l&&state[root(j)].r!=r)
            pq.push({-(state[root(j)].r-state[root(j)].l+1),root(j)});

    //cout<<"score= "<<score<<endl;

    while(pq.size()&&k_remain)
    {
        pair<int/*SZ*/,int/*root*/> tp=pq.top();
        pq.pop();

        if(root(tp.second)!=tp.second||state[root(tp.second)].r-state[root(tp.second)].l+1!=-tp.first)continue;

        int node=tp.second;

        int h_LHS=state[root(state[node].l-1)].h;
        int h_RHS=state[root(state[node].r+1)].h;

        if(h_LHS<state[node].h||h_RHS<state[node].h)continue;

        //cout<<tp.first<<" "<<tp.second<<" "<<state[node].l<<" "<<state[node].r<<" "<<state[node].h<<" "<<score<<" "<<k_remain<<endl;

        long long up=min(h_LHS,h_RHS)-state[node].h;

        if(k_remain/(-tp.first)<up)
        {
            score=score-k_remain/(-tp.first)*2;
            break;
        }

        score-=2*up;
        k_remain=k_remain-1LL*up*(-tp.first);

        state[node].h+=up;

        my_merge(root(state[node].l-1),node);
        my_merge(node,root(state[node].r+1));

        node=root(node);

        if(state[node].l!=l&&state[node].r!=r)pq.push({-(state[node].r-state[node].l+1),node});
    }

    //cout<<"score= "<<score<<endl;

    return score;
}

int dp[102][250][250];

int rec(int pos,int prv,int k_remain)
{
    if(pos>n)return 0;

    if(dp[pos][prv][k_remain]!=-1)return dp[pos][prv][k_remain];

    int ret=1e9;

    for(int j=0;j<=k_remain;j++)
        ret=min(ret,rec(pos+1,inp[pos]+j,k_remain-j)+abs(inp[pos]+j-prv));

    dp[pos][prv][k_remain]=ret;
    return ret;
}

int dumb()
{
    for(int i=1;i<=n;i++)
    {
        for(int j=0;j<=k+40;j++)
            for(int p=0;p<=k;p++)
                dp[i][j][p]=-1;
    }

    int outp=1e9;

    for(int i=0;i<=k;i++)
        outp=min(outp,rec(2,inp[1]+i,k-i));

    return outp;
}


long long solve()
{
    scanf("%i%lld",&n,&k);

    for(int i=1;i<=n;i++)scanf("%i",&inp[i]);

    /*
    n=5;
    k=1e9;

    for(int i=1;i<=n;i++)
        if(i%2)inp[i]=1e9;
        else inp[i]=1;
    */

    inp[0]=0;
    inp[n+1]=0;

    for(int i=1;i<=n;i++)pref[i]=inp[i]+pref[i-1];

    pref_MX[0]=0;
    for(int i=1;i<=n;i++)pref_MX[i]=max(pref_MX[i-1],inp[i]);

    suff_MX[n+1]=0;
    for(int i=n;i>=1;i--)suff_MX[i]=max(suff_MX[i+1],inp[i]);

    //cout<<"dumb= "<<dumb()<<endl;

    return eval(1,n,k);

    long long outp=1e18;

    for(int i=0;i<=n;i++)
        if(inp[i]==pref_MX[i]&&1LL*i*inp[i]-pref[i]<=k)
        {
            for(int j=n+1;j>i;j--)
                if(inp[j]==suff_MX[j]&&(1LL*i*inp[i]-pref[i])+(1LL*(n+1-j)*inp[j]-pref[n]+pref[j-1])<=k)
                {
                    outp=min(outp,eval(i,j,k-((1LL*i*inp[i]-pref[i])+(1LL*(n+1-j)*inp[j]-pref[n]+pref[j-1]))));
                }
        }

    return outp;
}

int main()
{
    int t;
    scanf("%i",&t);

    while(t)
    {
        t--;

        printf("%lld\n",solve());
    }

    return 0;
}
