#include<bits/stdc++.h>
using namespace std;
const int MAXN=1e5+6;

const int logN=17;
int n,m,s,t;
vector<int>g[MAXN];
vector<int>g1[MAXN];
vector<pair<int,int> >edges;
vector<pair<int,int> >be;
int dep[MAXN];
int dep1[MAXN];
int dep2[MAXN];
int par[MAXN];
int sz[MAXN];
int mindist[MAXN];
vector<int>g2[MAXN];
vector<int>gr[MAXN];
int time_in[MAXN];
int time_out[MAXN];
bool is_par(int x,int y)
{
    return (time_in[x]<=time_in[y]&&time_out[x]>=time_out[y]);
}
int timex=0;
int parsp[MAXN][logN];
void dfs_euler(int u)
{
    ++timex;
    time_in[u]=timex;
    sz[u]=1;
    for(auto xd:g2[u])
    {
        dfs_euler(xd);
        sz[u]+=sz[xd];
        parsp[xd][0]=u;
    }
    time_out[u]=timex;
}
void precompute()
{
    for(int s=1;s<logN;++s)
    {
        for(int i=1;i<=n;++i)
        {
            parsp[i][s]=parsp[parsp[i][s-1]][s-1];
        }
    }
}
int lca(int x,int y)
{
    if(is_par(x,y))return x;
    if(is_par(y,x))return y;
    for(int j=logN-1;j>=0;--j)
    {
        if(parsp[x][j]==0)continue;
        if(!is_par(parsp[x][j],y))
        {
            x=parsp[x][j];
        }
    }
    return parsp[x][0];
}
/*
backedge
-val = path + dep
-remove_when
*/
void dfs(int u,priority_queue<pair<int/*val*/,int/*remove_when*/> >&backedge)
{
    if(g2[u].size()==0)
    {
        for(auto xd:gr[u])
        {
            if(!is_par(u,lca(u,xd)))backedge.push({-dep[u]-dep[xd]-1,lca(u,xd)});
        }
        while(!backedge.empty()&&is_par(u,backedge.top().second))
        {
            backedge.pop();
        }
        if(!backedge.empty())
        {
            dep1[u]=-dep[u]-backedge.top().first;
        }
        //cout<<u<<" "<<dep1[u]<<endl;
        return;
    }
    int maxsz=-1,bch;
    for(auto xd:g2[u])
    {
        if(sz[xd]>maxsz)
        {
            maxsz=sz[xd];
            bch=xd;
        }
    }
    dfs(bch,backedge);
    for(auto xd:g2[u])
    {
        if(xd==bch)continue;
        priority_queue<pair<int,int> >tmp;
        dfs(xd,tmp);
        while(!tmp.empty())
        {
            if(!is_par(u,tmp.top().second))backedge.push(tmp.top());
            tmp.pop();
        }
    }
    for(auto xd:gr[u])
    {
        if(!is_par(u,lca(u,xd)))backedge.push({-dep[u]-dep[xd]-1,lca(u,xd)});
    }
    while(!backedge.empty()&&is_par(u,backedge.top().second))
    {
        backedge.pop();
    }
    if(!backedge.empty())
    {
        dep1[u]=-dep[u]-backedge.top().first;
    }
    //cout<<u<<" "<<dep1[u]<<endl;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    //cout<<be.size()<<endl;
    //n=1024;m=10240;s=0;t=n-1;
    cin>>n>>m>>s>>t;
    s++;t++;
    srand(124);
    for(int i=1;i<=m;++i)
    {
        int x,y;
        cin>>x>>y;
        //x=rand()%n;y=x;
        ++x;++y;
        g[x].push_back(y);
        g[y].push_back(x);
        if(x>y)swap(x,y);
        edges.push_back({x,y});
    }
    queue<int>q;
    q.push(t);
    memset(dep,-1,sizeof(dep));
    dep[t]=0;
    while(!q.empty())
    {
        int u=q.front();
        q.pop();
        for(auto xd:g[u])
        {
            if(dep[xd]==-1)
            {
                dep[xd]=dep[u]+1;
                par[xd]=u;
                q.push(xd);
            }
        }
    }
    for(int i=1;i<=n;++i)
    {
        if(i==t)continue;
        g2[par[i]].push_back(i);
        if(par[i]!=0)be.push_back({par[i],i});
    }
    multiset<pair<int,int> >edges1;
    for(auto xd:edges)
    {
        edges1.insert(xd);
    }
    for(auto xd:be)
    {
        if(xd.first>xd.second)swap(xd.first,xd.second);
        edges1.erase(edges1.find({xd.first,xd.second}));
    }
    for(auto xd:edges1)
    {
        gr[xd.first].push_back(xd.second);
        gr[xd.second].push_back(xd.first);
    }
    //cout<<be.size()<<endl;
    /*for(int i=0;i<be.size();i++)
    {
        //cout<<i<<" "<<be.size()<<endl;
        //if(be[i].first>be[i].second)swap(be[i].first,be[i].second);
        pair<int,int> rem=be[i];
        for(int j=1;j<=n;j++)
        {
            g1[j].clear();
        }
        for(int j=0;j<edges.size();j++)
        {
            if(edges[j].first==rem.first&&edges[j].second==rem.second)
            {
                rem={-1,-1};
            }
            else g1[edges[j].first].push_back({edges[j].second});
            if(edges[j].second==rem.first&&edges[j].first==rem.second)
            {
                rem={-1,-1};
            }
            else g1[edges[j].second].push_back({edges[j].first});

        }

        q.push(t);
        memset(dep2,-1,sizeof(dep2));
        dep2[t]=0;
        while(!q.empty())
        {
            int u=q.front();
            q.pop();
            for(auto xd:g1[u])
            {
                if(dep2[xd]==-1)
                {
                    dep2[xd]=dep2[u]+1;
                    q.push(xd);
                }
            }
        }
        dep1[be[i].second]=dep2[be[i].second];
    }*/
    //cout<<"-------------\n";
    memset(dep1,-1,sizeof(dep1));
    dfs_euler(t);
    precompute();
    priority_queue<pair<int,int> >lmao;
    dfs(t,lmao);
    dep1[t]=0;
    if(dep1[s]==-1)
    {
        cout<<"-1\n";
        return 0;
    }
    int low=0,high=2*n,best=3*n+1,mid;
    while(low<=high)
    {
        mid=(low+high)/2;
        memset(mindist,-1,sizeof(mindist));
        q.push(s);
        mindist[s]=0;
        while(!q.empty())
        {
            int u=q.front();
            q.pop();
            for(auto xd:g[u])
            {
                if(dep1[xd]==-1)continue;
                if(mindist[u]+1+dep1[xd]>mid)continue;
                if(mindist[xd]==-1)
                {
                    mindist[xd]=mindist[u]+1;
                    q.push(xd);
                    par[xd]=u;
                }
            }
        }
        if(mindist[t]==-1)
        {
            low=mid+1;
        }
        else
        {
            best=mid;
            high=mid-1;
        }
    }
    if(best==3*n+1)
    {
        cout<<"-1\n";
        return 0;
    }
    memset(mindist,-1,sizeof(mindist));
    q.push(s);
    mindist[s]=0;
    while(!q.empty())
    {
        int u=q.front();
        q.pop();
        for(auto xd:g[u])
        {
            if(dep1[xd]==-1)continue;
            if(mindist[u]+1+dep1[xd]>best)continue;
            if(mindist[xd]==-1)
            {
                mindist[xd]=mindist[u]+1;
                q.push(xd);
                par[xd]=u;
            }
        }
    }
    vector<int>path;
    path.push_back(t);
    while(path.back()!=s)path.push_back(par[path.back()]);
    reverse(path.begin(),path.end());
    cout<<best<<" "<<path.size()-1<<'\n';
    for(auto xd:path)
    {
        cout<<xd-1<<" ";
    }
    cout<<'\n';
return 0;
}

/*
7 10 0 6
0 1
0 2
1 1
1 3
2 3
3 4
3 4
4 5
4 6
5 6
*/
