#include<bits/stdc++.h>
using namespace std;
const int MAXN=100002;
int maxlen[MAXN];
int n;
struct point
{
    int x,y,t;
    bool operator<(point const& other)const
    {
        if(x!=other.x)return x<other.x;
        return y<other.y;
    }
};
vector<point>pts;
struct node
{
    int maxl;
    bitset<MAXN>p;
};
node fen[MAXN];
void update(int idx,int val,bitset<MAXN>pos)
{
    idx++;
    for(;idx<MAXN;idx+=idx&(-idx))
    {
        if(fen[idx].maxl<val)
        {
            fen[idx]={val,pos};
        }
        else if(fen[idx].maxl==val)fen[idx].p|=pos;
    }
}
node query(int idx)
{
    idx++;
    int maxl=0;
    bitset<MAXN>p;
    for(;idx>0;idx-=idx&(-idx))
    {
        if(fen[idx].maxl>maxl)
        {
            maxl=fen[idx].maxl;
            p=fen[idx].p;
        }
        else if(fen[idx].maxl==maxl)
        {
            p|=fen[idx].p;
        }
    }
    return {maxl,p};
}
int main()
{
    cin>>n;
    for(int i=1;i<=n;i++)
    {
        int x,y,t;
        cin>>x>>y>>t;
        pts.push_back({x,y,t});
    }
    sort(pts.begin(),pts.end());
    bitset<MAXN>p;
    p=0;
    p.set(0);
    for(int i=1;i<=n;i++)
    {
        update(i,0,p);
    }
    for(int i=0;i<pts.size();i++)
    {
        node f=query(pts[i].y);
        if(pts[i].t==1)f.p=(f.p<<1);
        update(pts[i].y,f.maxl+1,f.p);
        //cout<<i<<" "<<f.maxl+1<<endl;
    }
    node f=query(n+1);
    cout<<f.maxl<<" ";
    int mindiff=f.maxl;
    for(int i=0;i<MAXN;i++)
    {
        if(f.p[i])
        {
            mindiff=min(mindiff,abs(i-(f.maxl-i)));
        }
    }
    cout<<mindiff<<endl;
return 0;
}
