#include <bits/stdc++.h>
using namespace std;

const int maxn = 1000006;
long long t, n, k;
int a [maxn];

struct node{
    long long val, sz;
    node *l, *r;
    node(long long val){
        this->val = val;
        sz = 1;
        l = r = nullptr;
    }
};
using pnode = node*;
pnode first, last;
vector<pnode> nodes;
priority_queue <pair <int, int> > pq;

long long solve(){
    while (!pq.empty()) pq.pop();
    nodes.clear ();
    long long ans = 0;
    first = new node(a [0]);
    pnode p = first;
    for (int i = 1; i < n; i ++){
        ans += abs (a [i] - a [i - 1]);
        if (a [i] == a [i - 1]) p->sz ++;
        else{
            pnode pp = new node(a [i]);
            p->r = pp;
            pp->l = p;
            if (a [i] > a [i - 1] && p->l && p->l->val > p->val){
                pq.push({-p->sz, nodes.size ()});
                nodes.push_back(p);
            }
            p = pp;
        }
    }
    last = p;
    while (!pq.empty()){
        auto idx = pq.top();
        pq.pop();
        p = nodes [idx.second];
        if (p->l->val < p->r->val){
            long long x = (p->l->val - p->val) * p->sz;
            if (x > k){
                ans -= k / p->sz * 2;
                break;
            }
            else{
                k -= x;
                ans -= (p->l->val - p->val) * 2;
                pnode pp = new node(p->l->val);
                pp->sz = p->sz + p->l->sz;
                pp->r = p->r;
                p->r->l = pp;
                if (!p->l->l) first = pp;
                else{
                    p->l->l->r = pp;
                    pp->l = p->l->l;
                    if (pp->l->val > pp->val){
                        pq.push({-pp->sz, nodes.size ()});
                        nodes.push_back(pp);
                    }
                }
            }
        }
        else if (p->l->val > p->r->val){
            long long x = (p->r->val - p->val) * p->sz;
            if (x > k){
                ans -= k / p->sz * 2;
                break;
            }
            else{
                k -= x;
                ans -= (p->r->val - p->val) * 2;
                pnode pp = new node(p->r->val);
                pp->sz = p->sz + p->r->sz;
                pp->l = p->l;
                p->l->r = pp;
                if (!p->r->r) last = pp;
                else{
                    p->r->r->l = pp;
                    pp->r = p->r->r;
                    if (pp->r->val > pp->val){
                        pq.push({-pp->sz, nodes.size ()});
                        nodes.push_back(pp);
                    }
                }
            }
        }
        else{
            long long x = (p->l->val - p->val) * p->sz;
            if (x > k){
                ans -= k / p->sz * 2;
                break;
            }
            else{
                k -= x;
                ans -= (p->l->val - p->val) * 2;
                pnode pp = new node(p->l->val);
                pp->sz = p->l->sz + p->sz + p->r->sz;
                if (!p->l->l) first = pp;
                else{
                    p->l->l->r = pp;
                    pp->l = p->l->l;
                }
                if (!p->r->r) last = pp;
                else{
                    p->r->r->l = pp;
                    pp->r = p->r->r;
                }
                if (pp->l && pp->l->val > pp->val && pp->r && pp->r->val > pp->val){
                        pq.push({-pp->sz, nodes.size ()});
                        nodes.push_back(pp);
                    }
            }
        }
    }
    return ans;
}

int main (){

    ios::sync_with_stdio (false);
    cin.tie (0);

    cin >> t;
    while (t --){
        cin >> n >> k;
        for (int i = 0; i < n; i ++) cin >> a [i];
        long long aFirstInitial, aLastInitial, kInitial;
        do{
            aFirstInitial = a [0];
            aLastInitial = a [n - 1];
            kInitial = k;
            long long l = aFirstInitial, r = min (aFirstInitial + kInitial, (long long) 1000000000);
            while (l < r){
                int mid = l + r >> 1;
                a [0] = mid;
                k = kInitial - (a [0] - aFirstInitial);
                long long ans1 = solve();
                a [0] = mid + 1;
                k = kInitial - (a [0] - aFirstInitial);
                long long ans2 = solve();
                if (ans1 < ans2) r = mid;
                else l = mid + 1;
            }
            a [0] = l;
            kInitial -= a [0] - aFirstInitial;
            l = aLastInitial;
            r = min (aLastInitial + kInitial, (long long) 1000000000);
            while (l < r){
                int mid = l + r >> 1;
                a [n - 1] = mid;
                k = kInitial - (a [n - 1] - aLastInitial);
                long long ans1 = solve();
                a [n - 1] = mid + 1;
                k = kInitial - (a [n - 1] - aLastInitial);
                long long ans2 = solve();
                if (ans1 < ans2) r = mid;
                else l = mid + 1;
            }
            a [n - 1] = l;
            kInitial -= a [n - 1] - aLastInitial;
            k = kInitial;
        } while (a [0] != aFirstInitial || a [n - 1] != aLastInitial);
        cout << solve() << '\n';
    }

}
