#include <bits/stdc++.h>
using namespace std;

const int maxn = 1000006;
long long t, n, k;
int a [maxn];

struct node{
    long long val, sz;
    node *l, *r;
    node(long long val){
        this->val = val;
        sz = 1;
        l = r = nullptr;
    }
};
using pnode = node*;
pnode first, last;
vector<pnode> nodes;
priority_queue <pair <int, int> > pq;

long long solve(){
    while (!pq.empty()) pq.pop();
    nodes.clear ();
    long long ans = 0;
    first = new node(a [0]);
    pnode p = first;
    for (int i = 1; i < n; i ++){
        ans += abs (a [i] - a [i - 1]);
        if (a [i] == a [i - 1]) p->sz ++;
        else{
            pnode pp = new node(a [i]);
            p->r = pp;
            pp->l = p;
            if (a [i] > a [i - 1] && p->l && p->l->val > p->val){
                pq.push({-p->sz, nodes.size ()});
                nodes.push_back(p);
            }
            p = pp;
        }
    }
    last = p;
    while (!pq.empty()){
        auto idx = pq.top();
        pq.pop();
        p = nodes [idx.second];
        if (p->l->val < p->r->val){
            long long x = (p->l->val - p->val) * p->sz;
            if (x > k){
                ans -= k / p->sz * 2;
                break;
            }
            else{
                k -= x;
                ans -= (p->l->val - p->val) * 2;
                pnode pp = new node(p->l->val);
                pp->sz = p->sz + p->l->sz;
                pp->r = p->r;
                p->r->l = pp;
                if (!p->l->l) first = pp;
                else{
                    p->l->l->r = pp;
                    pp->l = p->l->l;
                    if (pp->l->val > pp->val){
                        pq.push({-pp->sz, nodes.size ()});
                        nodes.push_back(pp);
                    }
                }
            }
        }
        else if (p->l->val > p->r->val){
            long long x = (p->r->val - p->val) * p->sz;
            if (x > k){
                ans -= k / p->sz * 2;
                break;
            }
            else{
                k -= x;
                ans -= (p->r->val - p->val) * 2;
                pnode pp = new node(p->r->val);
                pp->sz = p->sz + p->r->sz;
                pp->l = p->l;
                p->l->r = pp;
                if (!p->r->r) last = pp;
                else{
                    p->r->r->l = pp;
                    pp->r = p->r->r;
                    if (pp->r->val > pp->val){
                        pq.push({-pp->sz, nodes.size ()});
                        nodes.push_back(pp);
                    }
                }
            }
        }
        else{
            long long x = (p->l->val - p->val) * p->sz;
            if (x > k){
                ans -= k / p->sz * 2;
                break;
            }
            else{
                k -= x;
                ans -= (p->l->val - p->val) * 2;
                pnode pp = new node(p->l->val);
                pp->sz = p->l->sz + p->sz + p->r->sz;
                if (!p->l->l) first = pp;
                else{
                    p->l->l->r = pp;
                    pp->l = p->l->l;
                }
                if (!p->r->r) last = pp;
                else{
                    p->r->r->l = pp;
                    pp->r = p->r->r;
                }
                if (pp->l && pp->l->val > pp->val && pp->r && pp->r->val > pp->val){
                        pq.push({-pp->sz, nodes.size ()});
                        nodes.push_back(pp);
                    }
            }
        }
    }
    return ans;
}

int main (){

    ios::sync_with_stdio (false);
    cin.tie (0);

    cin >> t;
    while (t --){
        cin >> n >> k;
        for (int i = 0; i < n; i ++) cin >> a [i];
        long long ans = 1000000000000000000;
        long long aFirstInitial = a [0], aLastInitial = a [n - 1], kInitial = k;
        for (int i = 0; i <= kInitial; i ++){
            for (int j = 0; j <= kInitial - i; j ++){
                a [0] = aFirstInitial + i;
                a [n - 1] = aLastInitial + j;
                k = kInitial - i - j;
                ans = min (ans, solve());
            }
        }
        cout << ans << '\n';
    }

}
