# include <bits/stdc++.h>
using namespace std;
const long long maxn = 1e5+5;
struct edge
{
    long long u,v;
    bool prohib;
};
edge p[1000005];
vector <long long> g[maxn];
long long dist[maxn], maxdist[maxn],vis[maxn],ids;
long long ans[maxn], from[maxn];
long long n;
void bfs(long long v)
{
    queue <long long> q;
    q.push(v);
    ids++;
    vis[v] = ids;
    dist[v] = 0;
    while(!q.empty())
    {
        v = q.front();
        q.pop();
        for(auto t: g[v])
        {
            if(p[t].prohib)continue;
            long long u = p[t].u;
            if(u==v)u = p[t].v;
            if(vis[u]!=ids)
            {
                dist[u] = dist[v]+1;
                vis[u] = ids;
                q.push(u);
            }
        }
    }
    for(long long i = 1; i <= n; i++)
    {
        if(vis[i]!=ids)
        {
            maxdist[i] = 1e9;
        }
        else
            maxdist[i]= max(maxdist[i],dist[i]);
    }
}
void dijkstra(long long v)
{
        priority_queue <pair <long long,long long> > q;
        ids++;
        vis[v] = ids;
        q.push({0,v});
        ans[v] = 0;
        while(!q.empty())
        {
            v= q.top().second;
            long long d = -q.top().first;
            q.pop();
            if(d!=ans[v])continue;
             for(auto t: g[v])
        {

            long long u = p[t].u;
            if(u==v)u = p[t].v;
            if(vis[u]==ids)continue;
            ans[u] = max(maxdist[u], ans[v]+1);
            vis[u] = ids;
            from[u] = v;
            q.push({-ans[u],u});
        }
        }
        for(int i = 1;i<=n;i++)
        if(vis[v]!=ids)
            ans[v] = 1e9;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    long long m,s,t;
    cin>>n>>m>>s>>t;
    long long i;
    long long x,y;
    for(i = 1;i<=m;i++)
    {
        cin>>x>>y;
       p[i].u = x;
       p[i].v = y;
       p[i].prohib = 0;
       g[x].push_back(i);
       g[y].push_back(i);
    }
    for(i = 1;i<=m;i++)
    {
        p[i].prohib = 1;
        bfs(t);
        p[i].prohib = 0;
    }
    dijkstra(t);
    long long ANS = ans[s];
    if(ANS>=1e9)
    {
        cout<<-1<<endl;
        return 0;
    }
    vector <long long> route;
    while(s!=t)
    {
        route.push_back(s);
        s = from[s];
    }
    route.push_back(t);
    cout<<ANS<<" "<<route.size()-1<<endl;
    for(auto z:route)cout<<z<<" ";
    cout<<endl;
}
