# include <bits/stdc++.h>
using namespace std;
const long long maxn = 1e5+5;
struct edge
{
    long long u,v;
    bool prohib;
};
edge p[1000005];
vector <long long> g[maxn];
long long dist[maxn], maxdist[maxn],vis[maxn],ids;
long long ans[maxn], from[maxn];
long long n;
long long MAX(long long A, long long B)
{
    if(A>B)return A;
    return B;
} queue <long long> q;
void bfs(long long v)
{

    q.push(v);
    ids++;
    vis[v] = ids;
    dist[v] = 0;
    int u;
    while(!q.empty())
    {
        v = q.front();
        q.pop();
        for(auto t: g[v])
        {
            if(p[t].prohib)continue;
            u = p[t].u;
            if(u==v)u = p[t].v;
            if(vis[u]!=ids)
            {
                dist[u] = dist[v]+1;
                vis[u] = ids;
                q.push(u);
            }
        }
    }
    int i;
    for(i = 0; i < n; i++)
    {
        if(vis[i]!=ids)
        {
            maxdist[i] = 1e9;
        }
        else
            maxdist[i]= MAX(maxdist[i],dist[i]);
    }
}
 priority_queue <pair <long long,long long> > pq;
void dijkstra(long long v)
{

        ids++;
        from[v] = -1;
        vis[v] = ids;
        pq.push({0,v});
        ans[v] = 0;
        int d,i,u;
        while(!pq.empty())
        {
            v= pq.top().second;
           d = -pq.top().first;
            pq.pop();
            if(d!=ans[v])continue;
             for(auto t: g[v])
        {

             u = p[t].u;
            if(u==v)u = p[t].v;
            if(vis[u]==ids)continue;
            ans[u] = MAX(maxdist[u], ans[v]+1);
            vis[u] = ids;
            from[u] = v;
            pq.push({-ans[u],u});
        }
        }
        for(int i = 0;i<n;i++)
        if(vis[v]!=ids)
            ans[v] = 1e9;
}
    vector <int> route;
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    long long m,s,t;
    cin>>n>>m>>s>>t;
    long long i;
    long long x,y;
    for(i = 1;i<=m;i++)
    {
        cin>>x>>y;
       p[i].u = x;
       p[i].v = y;
       p[i].prohib = 0;
       g[x].push_back(i);
       g[y].push_back(i);
    }
    for(i = 1;i<=m;i++)
    {
        p[i].prohib = 1;
        bfs(t);
        p[i].prohib = 0;
    }
    dijkstra(t);
    long long ANS = ans[s];
    if(ANS>=1e9)
    {
        cout<<-1<<endl;
        return 0;
    }

    while(s!=t)
    {
        route.push_back(s);
        s = from[s];
        if(route.size()>n)
        {
            cout<<-1<<endl;
            return 0;
        }
    }
    route.push_back(t);
    cout<<ANS<<" "<<route.size()-1<<endl;
    for(auto z:route)cout<<z<<" ";
    cout<<endl;
}
