#include<bits/stdc++.h>
#define MAXN 2000007
using namespace std;

struct edge{
    int from;
    int to;
    int cost;
};

int n,m,s,t,a[MAXN],b[MAXN],curr,dest,best,minv;
vector< pair<int,int> > v[MAXN];
vector< edge> e;
int li[MAXN],dist[MAXN],tim,dp[MAXN];
pair<int,int> res[MAXN];
queue<int> q;

void bfs(int x){
    for(int i=0;i<v[x].size();i++){
        if(li[v[x][i].first]==tim or v[x][i].second==curr)continue;
        dist[v[x][i].first]=dist[x]+1;
        li[v[x][i].first]=tim;
        q.push(v[x][i].first);
    }
}

vector< pair<int,int> > tree[MAXN];
vector<int> path;

int dfs(int x){
    if(x%n==s)return 0;

    if(li[x]==tim)return dp[x];
    li[x]=tim;

    dp[x]=100000000;
    for(int i=0;i<tree[x].size();i++){
        dp[x]=min(dp[x],max(dfs(tree[x][i].first),tree[x][i].second));
    }

    return dp[x];
}

void dfs2(int x){
    if(x%n==s){
        path.push_back(s);
        return;
    }

    for(int i=0;i<tree[x].size();i++){
        if(max(dp[tree[x][i].first],tree[x][i].second)<=dp[x]){
            dfs2(tree[x][i].first);
            path.push_back(x%n);
            return;
        }
    }
}

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>m>>s>>t;
    for(int i=1;i<=m;i++){
        cin>>a[i]>>b[i];
        v[a[i]].push_back({b[i],i});
        v[b[i]].push_back({a[i],i});
    }

    for(int i=1;i<=m;i++){
        if(a[i]==b[i])continue;
        for(int f=0;f<=n;f++)dist[f]=100000000;
        curr=i;

        q.push(t); dist[t]=0;
        tim++; li[t]=tim;
        while(!q.empty()){
            bfs(q.front());
            q.pop();
        }

        res[i]={dist[a[i]],dist[b[i]]};
    }

    for(int i=1;i<=m;i++){
        for(int f=0;f<=n-1;f++){
            e.push_back({a[i]+f*n,b[i]+(f+1)*n,f+res[i].first});
            e.push_back({b[i]+f*n,a[i]+(f+1)*n,f+res[i].second});
        }
    }
    for(int i=0;i<e.size();i++){
        tree[e[i].to].push_back({e[i].from,e[i].cost});
    }
    
    return 0;

    best=100000000; tim++;
    for(int i=1;i<=n;i++){
        curr=dfs(t+i*n);
        if(curr<best){
            best=curr;
            dest=t+i*n;
        }
    }

    dfs2(dest);

    if(best==100000000){
        cout<<"-1\n";
        return 0;
    }
    cout<<best<<" "<<path.size()-1<<"\n";
    for(int i=0;i<path.size();i++){
        cout<<path[i]<<" ";
    }
    cout<<"\n";

    return 0;
}

