#include<bits/stdc++.h>
#define MAXN 1000007
using namespace std;

struct edge{
    int from;
    int to;
    int cost;
};

int n,m,s,t,a[MAXN],b[MAXN],curr,dest,best,minv;
vector< pair<int,int> > v[MAXN];
vector< edge> e;
int li[MAXN],dist[MAXN],tim,dp[MAXN],parent[MAXN];
pair<int,int> res[MAXN];
queue<int> q;
priority_queue< pair<int,int> , vector< pair<int,int> > , greater< pair<int,int> > > pq;

void bfs(int x){
    for(int i=0;i<v[x].size();i++){
        if(li[v[x][i].first]==tim or v[x][i].second==curr)continue;
        dist[v[x][i].first]=dist[x]+1;
        li[v[x][i].first]=tim;
        q.push(v[x][i].first);
    }
}

vector< pair<int,int> > tree[MAXN];
vector<int> path;

void prim(){
    for(int i=0;i<=n;i++)dist[i]=100000000;
    pq.push({0,s}); tim++; dist[s]=0;
    while(!pq.empty()){
        minv=pq.top().second;
        pq.pop();
        li[minv]=tim;

        for(int i=0;i<tree[minv].size();i++){
            if(li[tree[minv][i].first]!=tim and max(dist[minv],tree[minv][i].second)<dist[tree[minv][i].first]){
                dist[tree[minv][i].first]=max(dist[minv],tree[minv][i].second);
                pq.push({dist[tree[minv][i].first],tree[minv][i].first});
                parent[tree[minv][i].first]=minv;
            }
        }
    }
}

void dfs(int x){
    if(x==s){
        path.push_back(s);
        return;
    }
    dfs(parent[x]);
    path.push_back(x);
}

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>m>>s>>t;
    for(int i=1;i<=m;i++){
        cin>>a[i]>>b[i];
        v[a[i]].push_back({b[i],i});
        v[b[i]].push_back({a[i],i});
    }

    for(int i=1;i<=m;i++){
        if(a[i]==b[i])continue;
        for(int f=0;f<=n;f++)dist[f]=100000000;
        curr=i;

        q.push(t); dist[t]=0;
        tim++; li[t]=tim;
        while(!q.empty()){
            bfs(q.front());
            q.pop();
        }

        res[i]={dist[a[i]],dist[b[i]]};
    }

    curr=0;
    for(int f=0;f<=n;f++)dist[f]=100000000;
    q.push(s); dist[s]=0;
    tim++; li[s]=tim;
    while(!q.empty()){
        bfs(q.front());
        q.pop();
    }

    for(int i=1;i<=m;i++){
        tree[b[i]].push_back({a[i],dist[b[i]]+res[i].second});
        tree[a[i]].push_back({b[i],dist[a[i]]+res[i].first});
    }

    prim();
    dfs(t);
    
    if(dist[t]==100000000){
        cout<<"-1\n";
        return 0;
    }

    cout<<dist[t]<<" "<<path.size()-1<<"\n";
    for(int i=0;i<path.size();i++){
        cout<<path[i]<<" ";
    }
    cout<<"\n";

    return 0;
}

