// Gumza, ti li si be

#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <cstring>
#define int long long

const int maxn = 10; //5000 + 10;
const int inf = 2e9;

std::unordered_set < int > s;
int key(int x, int y, int type)
{
    return type-1 + 2*y + 2*maxn*x;
}

int dp[2][maxn][maxn];
int n;

void solve()
{
    std::fill(&dp[0][0][0], &dp[1][maxn-1][maxn-1]+1, -inf);
    for (int i = 0 ; i <= n ; ++i)
        dp[(n+1)&1][i][0] = 0;
    for (int i = n ; i >= 0 ; --i)
    {
        dp[i&1][n+1][0] = 0;
        for (int j = n ; j >= 0 ; --j)
        {
            int here = 0;
            if (s.count(key(i, j, 1))) here = 1;
            if (s.count(key(i, j, 2))) here = 2;
            for (int cnt = 0 ; cnt < maxn ; ++cnt)
            {
                if (here == 1 && cnt == 0)
                {
                    dp[i&1][j][cnt] = -inf;
                    continue;
                }
                dp[i&1][j][cnt] = dp[i&1][j+1][cnt - (here == 1)] + (here != 0);
                dp[i&1][j][cnt] = std::max(dp[i&1][j][cnt], dp[(i+1)&1][j][cnt - (here == 1)] + (here != 0));
            }
        }
    }

    int ans = 0, ix = 0;
    for (int i = 0 ; i < maxn ; ++i)
    {
        if (dp[0][0][i] > ans || (dp[0][0][i] == ans && abs(ans-2*ix) > abs(ans-2*i)))
        {
            ans = dp[0][0][i];
            ix = i;
        }
    }

    std::cout << ans << ' ' << abs(ans-2*ix) << '\n';
}

void read()
{
    int x, y, type;
    std::cin >> n;
    for (int i = 1 ; i <= n ; ++i)
    {
        std::cin >> x >> y >> type;
        s.insert(key(x, y, type));
    }
}

void fastIO()
{
    std::ios_base :: sync_with_stdio(0);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
}

signed main()
{
    fastIO();
    read();
    solve();

    return 0;
}

/*
4
1 2 1
2 1 2
3 1 1
4 3 2
*/
