#include <iostream>
#define endl '\n'
using namespace std;

const int MAXN = 400;

int a[MAXN + 5][MAXN + 5];
int dp[MAXN + 5][MAXN + 5][2 * MAXN + 5];

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n;
    cin >> n;

    for (int i = 1; i <= n; ++ i)
    {
        int x, y, t;
        cin >> x >> y >> t;
        x++;
        y++;
        a[x][y] = t;
    }
    n++;

    for (int i = 0; i <= n; ++ i)
    {
        for (int j = 0; j <= n; ++ j)
        {
            for (int k = -n; k <= n; ++ k)
            {
                dp[i][j][k + n] = -n;
            }
        }
    }

    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= n; ++ j)
        {
            if (i == 1 and j == 1)
            {
                dp[i][j][n] = 0;
                continue;
            }
            for (int k = -n; k <= n; ++ k)
            {
                if (a[i][j] == 0) dp[i][j][k + n] = max(dp[i - 1][j][k + n], dp[i][j - 1][k + n]);
                else if (a[i][j] == 1 and k + n > 0) dp[i][j][k + n] = max(dp[i - 1][j][k - 1 + n] + 1, dp[i][j - 1][k - 1 + n] + 1);
                else if (a[i][j] == 2 and k + n < 2 * n) dp[i][j][k + n] = max(dp[i - 1][j][k + 1 + n] + 1, dp[i][j - 1][k + 1 + n] + 1);
            }
        }
    }

    int mx = 0, Abs = 0;
    for (int k = -n; k <= n; ++ k)
    {
        if (dp[n][n][k + n] > mx)
        {
            mx = dp[n][n][k + n];
            Abs = (k > 0 ? k : -k);
        }
        else if (dp[n][n][k + n] == mx)
        {
            Abs = max(Abs, (k > 0 ? k : -k));
        }
    }

    cout << mx << " " << Abs << endl;

    return 0;
}
