#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

const ll maxn = 1e6 + 10, maxv = 41, maxk = 201;
const ll inf = 1e18;

ll n;
ll k, v[maxn], dp[maxn];

struct llerval
{
    ll l, r;
    ll price;


    bool operator < (const llerval &it) const
    {
        return price > it.price;
    }
};
void solve()
{
    cin >> n >> k;
    ll cur = 0;
    for (ll i = 1; i <= n; i ++)
    {
        cin >> v[i];
        if (i > 1)
            cur = cur + abs(v[i] - v[i - 1]);
    }

    priority_queue < llerval > q;
    ll i = 1;
    while(i <= n)
    {
        ll j = i;
        while(j <= n && v[j] == v[i])
            j ++;
        if (v[j] > v[i] && v[i - 1] > v[i])
        {
            llerval it;
            it.l = i;
            it.r = j - 1;
            it.price = (j - i);

            q.push(it);
        }

        i = j;
    }

    ll rem = 0;
    while(k > 0 && !q.empty())
    {
        llerval it = q.top();
        q.pop();

        ll tp = min(k / it.price, (v[it.l - 1] - v[it.l]));

        rem = rem + tp * 2;
        k = k - tp * it.price;
        if (tp != v[it.l - 1] - v[it.l])
        {

            break;
        }

        ll j = it.l;
        while(j > 0 && v[j] == v[i] + tp)
            j --;

        it.l = j;
        if (j == 0)
            it.l = 1;

        j = it.r;
        while(j <= n && v[j] == v[i] + tp)
            j ++;

        it.r = j;
        if (j > n)
            it.r = n;

        it.price = (it.r - it.l + 1);
        if (v[it.l - 1] > v[it.l] && v[it.r + 1] > v[it.r])
        q.push(it);
    }

    cout << cur - rem << endl;


}

int main ()
{
    ll t;
    cin >> t;
    while(t --)
    solve();
    return 0;
}
/**
1
8 2
100 6 3 3 3 4 3 100
*/
