#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

const ll maxn = 1e6 + 10, maxv = 41, maxk = 201;
const ll inf = 1e18;

ll n;
ll k, v[maxn], dp[maxn];

struct interval
{
    ll l, r;
    ll price;


    bool operator < (const interval &it) const
    {
        return price > it.price;
    }
};
void solve()
{
    cin >> n >> k;
    if (n == 1)
    {
        cout << 0 << endl;
        return;
    }
    ll cur = 0;
    for (ll i = 1; i <= n; i ++)
    {
        cin >> v[i];
        if (i > 1)
            cur = cur + abs(v[i] - v[i - 1]);
    }

    priority_queue < interval > q;
    ll i = 1;
    while(i <= n)
    {
        ll j = i;
        while(j <= n && v[j] == v[i])
            j ++;
        if (v[j] > v[i] && v[i - 1] > v[i])
        {
            interval it;
            it.l = i;
            it.r = j - 1;
            it.price = (j - i);

            q.push(it);
        }

        i = j;
    }

    ll rem = 0;
    bool happ = false;
    while(k > 0 && !q.empty())
    {
        interval it = q.top();
        ///cout << it.price << " " << rem << endl;
        if (it.price >= 2 && !happ)
        {
            happ = true;
            if (v[1] < v[2])
            {
                ll tp = min(k, (v[2] - v[1]) - 1);
                k = k - tp;
                rem = rem + tp;
                if (tp != (v[2] - v[1]) - 1)
                    break;
                v[1] += tp;
            }
            if (v[n] < v[n - 1])
            {
                ll tp = min(k, (v[n - 1] - v[n]) - 1);
                k = k - tp;
                rem = rem + tp;
                if (tp != (v[n - 1] - v[n]) - 1)
                    break;
                v[n] += tp;
            }
            continue;
        }
        q.pop();

        if (it.l == 1 && it.r == n)
            break;
        ll big = min(v[it.l - 1], v[it.r + 1]);
        if (it.l == 1)
            big = v[it.r + 1];
        if (it.r == n)
        big = v[it.l - 1];
        ll tp = min(k / it.price, big - v[it.l]);
        ///cout << k << " " << it.price << " " << tp << endl;
        rem = rem + tp * 2;
        k = k - tp * it.price;
        if (tp != big - v[it.l])
        {
            break;
        }

        ll j = it.l - 1;
        ll sh = v[it.l] + tp;
        while(j > 0 && v[j] == sh)
            j --;

        it.l = j + 1;

        j = it.r + 1;
        while(j <= n && v[j] == sh)
            j ++;

        it.r = j - 1;

        it.price = (it.r - it.l + 1);
        v[it.l] = sh;
        v[it.r] = sh;
        if (v[it.l - 1] > v[it.l] && v[it.r + 1] > v[it.r])
        q.push(it);
    }

    if (k > 0)
    {
         if (v[1] < v[2])
            {
                ll pos = v[2] - v[1];
                ll tp = min(pos, k);
                k = k - tp;
                rem = rem + tp;

                interval cr;
                int j = 2;
                while(j <= n && v[j] == v[2])
                    j ++;
                cr.l = 1;
                cr.r = j - 1;
                v[cr.l] = v[2];
                v[cr.r] = v[2];
                cr.price = cr.r - cr.l + 1;
                if (cr.r == n || v[cr.r + 1] > v[cr.r])
                q.push(cr);
            }

            if (v[n] < v[n - 1])
            {
                ll pos = v[n - 1] - v[n];
                ll tp = min(pos, k);
                k = k - tp;
                rem = rem + tp;


                interval cr;
                int j = n - 1;
                while(j > 0 && v[j] == v[n - 1])
                    j --;
                cr.l = j + 1;
                cr.r = n;
                v[cr.l] = v[n - 1];
                v[cr.r] = v[n - 1];
                cr.price = cr.r - cr.l + 1;
                if (cr.l == 1 || v[cr.l - 1] > v[cr.l])
                q.push(cr);
            }

            while(k > 0 && !q.empty())
    {
        interval it = q.top();
        q.pop();

        if (it.l == 1 && it.r == n)
            break;
        ll big = min(v[it.l - 1], v[it.r + 1]);
        if (it.l == 1)
            big = v[it.r + 1];
        if (it.r == n)
        big = v[it.l - 1];
        ll tp = min(k / it.price, big - v[it.l]);
        ///cout << k << " " << it.price << " " << tp << endl;
        rem = rem + tp * 2;
        k = k - tp * it.price;
        if (tp != big - v[it.l])
        {
            break;
        }

        ll j = it.l - 1;
        ll sh = v[it.l] + tp;
        while(j > 0 && v[j] == sh)
            j --;

        it.l = j + 1;

        j = it.r + 1;
        while(j <= n && v[j] == sh)
            j ++;

        it.r = j - 1;

        it.price = (it.r - it.l + 1);
        v[it.l] = sh;
        v[it.r] = sh;
        if (v[it.l - 1] > v[it.l] && v[it.r + 1] > v[it.r])
        q.push(it);
    }
    }
    cout << cur - rem << endl;


}

int main ()
{
    ll t;
    cin >> t;
    while(t --)
    solve();
    return 0;
}
/**
1
8 2
100 6 3 3 3 4 3 100
*/
